// gpu/ipc/common/shared_image_capabilities.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef GPU_IPC_COMMON_SHARED_IMAGE_CAPABILITIES_MOJOM_SHARED_H_
#define GPU_IPC_COMMON_SHARED_IMAGE_CAPABILITIES_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "gpu/ipc/common/shared_image_capabilities.mojom-shared-internal.h"
#include "ui/gfx/mojom/buffer_types.mojom-shared.h"



#include "base/component_export.h"




namespace gpu::mojom {
class SharedImageCapabilitiesDataView;



}  // gpu::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::gpu::mojom::SharedImageCapabilitiesDataView> {
  using Data = ::gpu::mojom::internal::SharedImageCapabilities_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace gpu::mojom {


class SharedImageCapabilitiesDataView {
 public:
  SharedImageCapabilitiesDataView() = default;

  SharedImageCapabilitiesDataView(
      internal::SharedImageCapabilities_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  bool supports_scanout_shared_images() const {
    return data_->supports_scanout_shared_images;
  }
  bool supports_luminance_shared_images() const {
    return data_->supports_luminance_shared_images;
  }
  bool supports_r16_shared_images() const {
    return data_->supports_r16_shared_images;
  }
  bool is_r16f_supported() const {
    return data_->is_r16f_supported;
  }
  bool disable_r8_shared_images() const {
    return data_->disable_r8_shared_images;
  }
  bool disable_webgpu_shared_images() const {
    return data_->disable_webgpu_shared_images;
  }
  bool shared_image_d3d() const {
    return data_->shared_image_d3d;
  }
  bool shared_image_swap_chain() const {
    return data_->shared_image_swap_chain;
  }
  inline void GetTextureTargetExceptionListDataView(
      mojo::ArrayDataView<::gfx::mojom::BufferUsageAndFormatDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadTextureTargetExceptionList(UserType* output) {
    
    auto* pointer = data_->texture_target_exception_list.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::gfx::mojom::BufferUsageAndFormatDataView>>(
        pointer, output, message_);
  }
 private:
  internal::SharedImageCapabilities_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // gpu::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::gpu::mojom::SharedImageCapabilitiesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::gpu::mojom::SharedImageCapabilitiesDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::gpu::mojom::internal::SharedImageCapabilities_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->supports_scanout_shared_images = Traits::supports_scanout_shared_images(input);
    fragment->supports_luminance_shared_images = Traits::supports_luminance_shared_images(input);
    fragment->supports_r16_shared_images = Traits::supports_r16_shared_images(input);
    fragment->is_r16f_supported = Traits::is_r16f_supported(input);
    fragment->disable_r8_shared_images = Traits::disable_r8_shared_images(input);
    fragment->disable_webgpu_shared_images = Traits::disable_webgpu_shared_images(input);
    fragment->shared_image_d3d = Traits::shared_image_d3d(input);
    fragment->shared_image_swap_chain = Traits::shared_image_swap_chain(input);
    decltype(Traits::texture_target_exception_list(input)) in_texture_target_exception_list = Traits::texture_target_exception_list(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->texture_target_exception_list)::BaseType>
        texture_target_exception_list_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& texture_target_exception_list_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<::gfx::mojom::BufferUsageAndFormatDataView>>(
        in_texture_target_exception_list, texture_target_exception_list_fragment, &texture_target_exception_list_validate_params);
    fragment->texture_target_exception_list.Set(
        texture_target_exception_list_fragment.is_null() ? nullptr : texture_target_exception_list_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->texture_target_exception_list.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null texture_target_exception_list in SharedImageCapabilities struct");
  }

  static bool Deserialize(::gpu::mojom::internal::SharedImageCapabilities_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::gpu::mojom::SharedImageCapabilitiesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace gpu::mojom {

inline void SharedImageCapabilitiesDataView::GetTextureTargetExceptionListDataView(
    mojo::ArrayDataView<::gfx::mojom::BufferUsageAndFormatDataView>* output) {
  auto pointer = data_->texture_target_exception_list.Get();
  *output = mojo::ArrayDataView<::gfx::mojom::BufferUsageAndFormatDataView>(pointer, message_);
}



}  // gpu::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // GPU_IPC_COMMON_SHARED_IMAGE_CAPABILITIES_MOJOM_SHARED_H_