// services/webnn/public/mojom/webnn_buffer.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/webnn/public/mojom/webnn_buffer.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/features.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/webnn/public/mojom/webnn_buffer.mojom-params-data.h"
#include "services/webnn/public/mojom/webnn_buffer.mojom-shared-message-ids.h"

#include "services/webnn/public/mojom/webnn_buffer.mojom-import-headers.h"
#include "services/webnn/public/mojom/webnn_buffer.mojom-test-utils.h"


namespace webnn::mojom {
BufferInfo::BufferInfo()
    : size() {}

BufferInfo::BufferInfo(
    uint64_t size_in)
    : size(std::move(size_in)) {}

BufferInfo::~BufferInfo() = default;
size_t BufferInfo::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->size);
  return seed;
}

void BufferInfo::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "size"), this->size,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool BufferInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ReadBufferResult::ReadBufferResult() : tag_(Tag::kBuffer) {
  data_.buffer = new ::mojo_base::BigBuffer;
}

ReadBufferResult::~ReadBufferResult() {
  DestroyActive();
}


void ReadBufferResult::set_buffer(
    ::mojo_base::BigBuffer buffer) {
  if (tag_ == Tag::kBuffer) {
    *(data_.buffer) = std::move(buffer);
  } else {
    DestroyActive();
    tag_ = Tag::kBuffer;
    data_.buffer = new ::mojo_base::BigBuffer(
        std::move(buffer));
  }
}
void ReadBufferResult::set_error(
    ::webnn::mojom::ErrorPtr error) {
  if (tag_ == Tag::kError) {
    *(data_.error) = std::move(error);
  } else {
    DestroyActive();
    tag_ = Tag::kError;
    data_.error = new ::webnn::mojom::ErrorPtr(
        std::move(error));
  }
}

void ReadBufferResult::DestroyActive() {
  switch (tag_) {

    case Tag::kBuffer:

      delete data_.buffer;
      break;
    case Tag::kError:

      delete data_.error;
      break;
  }
}

bool ReadBufferResult::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}
const char WebNNBuffer::Name_[] = "webnn.mojom.WebNNBuffer";

WebNNBuffer::IPCStableHashFunction WebNNBuffer::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (static_cast<messages::WebNNBuffer>(message.name())) {
    case messages::WebNNBuffer::kReadBuffer: {
      return &WebNNBuffer::ReadBuffer_Sym::IPCStableHash;
    }
    case messages::WebNNBuffer::kWriteBuffer: {
      return &WebNNBuffer::WriteBuffer_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* WebNNBuffer::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (static_cast<messages::WebNNBuffer>(message.name())) {
      case messages::WebNNBuffer::kReadBuffer:
            return "Receive webnn::mojom::WebNNBuffer::ReadBuffer";
      case messages::WebNNBuffer::kWriteBuffer:
            return "Receive webnn::mojom::WebNNBuffer::WriteBuffer";
    }
  } else {
    switch (static_cast<messages::WebNNBuffer>(message.name())) {
      case messages::WebNNBuffer::kReadBuffer:
            return "Receive reply webnn::mojom::WebNNBuffer::ReadBuffer";
      case messages::WebNNBuffer::kWriteBuffer:
            return "Receive reply webnn::mojom::WebNNBuffer::WriteBuffer";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t WebNNBuffer::ReadBuffer_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)webnn::mojom::WebNNBuffer::ReadBuffer");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t WebNNBuffer::WriteBuffer_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)webnn::mojom::WebNNBuffer::WriteBuffer");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

class WebNNBuffer_ReadBuffer_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  WebNNBuffer_ReadBuffer_ForwardToCallback(
      WebNNBuffer::ReadBufferCallback callback
      ) : callback_(std::move(callback)) {
  }

  WebNNBuffer_ReadBuffer_ForwardToCallback(const WebNNBuffer_ReadBuffer_ForwardToCallback&) = delete;
  WebNNBuffer_ReadBuffer_ForwardToCallback& operator=(const WebNNBuffer_ReadBuffer_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  WebNNBuffer::ReadBufferCallback callback_;
};

WebNNBufferProxy::WebNNBufferProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void WebNNBufferProxy::ReadBuffer(
    ReadBufferCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "Send webnn::mojom::WebNNBuffer::ReadBuffer");
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;

  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::WebNNBuffer::kReadBuffer), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNBuffer_ReadBuffer_Params_Data> params(
          message);
  params.Allocate();

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNBuffer::Name_);
  message.set_method_name("ReadBuffer");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new WebNNBuffer_ReadBuffer_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}

void WebNNBufferProxy::WriteBuffer(
    ::mojo_base::BigBuffer in_src_buffer) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send webnn::mojom::WebNNBuffer::WriteBuffer", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("src_buffer"), in_src_buffer,
                        "<value of type ::mojo_base::BigBuffer>");
   });
#endif

  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;

  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::WebNNBuffer::kWriteBuffer), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNBuffer_WriteBuffer_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<decltype(params->src_buffer)>
      src_buffer_fragment(params.message());
  src_buffer_fragment.Claim(&params->src_buffer);
  mojo::internal::Serialize<::mojo_base::mojom::BigBufferDataView>(
      in_src_buffer, src_buffer_fragment, true);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->src_buffer.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null src_buffer in WebNNBuffer.WriteBuffer request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNBuffer::Name_);
  message.set_method_name("WriteBuffer");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}
class WebNNBuffer_ReadBuffer_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static WebNNBuffer::ReadBufferCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<WebNNBuffer_ReadBuffer_ProxyToResponder> proxy(
        new WebNNBuffer_ReadBuffer_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&WebNNBuffer_ReadBuffer_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~WebNNBuffer_ReadBuffer_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  WebNNBuffer_ReadBuffer_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "WebNNBuffer::ReadBufferCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      ReadBufferResultPtr in_result);
};

bool WebNNBuffer_ReadBuffer_ForwardToCallback::Accept(
    mojo::Message* message) {
  DCHECK(message->is_serialized());
  internal::WebNNBuffer_ReadBuffer_ResponseParams_Data* params =
      reinterpret_cast<
          internal::WebNNBuffer_ReadBuffer_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for WebNNBuffer.0
  bool success = true;
  ReadBufferResultPtr p_result{};
  WebNNBuffer_ReadBuffer_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        WebNNBuffer::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result));
  return true;
}

void WebNNBuffer_ReadBuffer_ProxyToResponder::Run(
    ReadBufferResultPtr in_result) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply webnn::mojom::WebNNBuffer::ReadBuffer", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("result"), in_result,
                        "<value of type ReadBufferResultPtr>");
   });
#endif

  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::WebNNBuffer::kReadBuffer), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNBuffer_ReadBuffer_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<decltype(params->result)>
      result_fragment(params.message());
  result_fragment.Claim(&params->result);
  mojo::internal::Serialize<::webnn::mojom::ReadBufferResultDataView>(
      in_result, result_fragment, true);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->result.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null result in ");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNBuffer::Name_);
  message.set_method_name("ReadBuffer");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool WebNNBufferStubDispatch::Accept(
    WebNNBuffer* impl,
    mojo::Message* message) {
  switch (static_cast<messages::WebNNBuffer>(message->header()->name)) {
    case messages::WebNNBuffer::kReadBuffer: {
      break;
    }
    case messages::WebNNBuffer::kWriteBuffer: {
      DCHECK(message->is_serialized());
      internal::WebNNBuffer_WriteBuffer_Params_Data* params =
          reinterpret_cast<internal::WebNNBuffer_WriteBuffer_Params_Data*>(
              message->mutable_payload());
      
      
      // Validation for WebNNBuffer.1
      bool success = true;
      ::mojo_base::BigBuffer p_src_buffer{};
      WebNNBuffer_WriteBuffer_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadSrcBuffer(&p_src_buffer))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WebNNBuffer::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->WriteBuffer(        
        std::move(p_src_buffer));
      return true;
    }
  }
  return false;
}

// static
bool WebNNBufferStubDispatch::AcceptWithResponder(
    WebNNBuffer* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (static_cast<messages::WebNNBuffer>(message->header()->name)) {
    case messages::WebNNBuffer::kReadBuffer: {
      internal::WebNNBuffer_ReadBuffer_Params_Data* params =
          reinterpret_cast<
              internal::WebNNBuffer_ReadBuffer_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for WebNNBuffer.0
      bool success = true;
      WebNNBuffer_ReadBuffer_ParamsDataView input_data_view(params, message);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WebNNBuffer::Name_, 0, false);
        return false;
      }
      WebNNBuffer::ReadBufferCallback callback =
          WebNNBuffer_ReadBuffer_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->ReadBuffer(std::move(callback));
      return true;
    }
    case messages::WebNNBuffer::kWriteBuffer: {
      break;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kWebNNBufferValidationInfo[] = {
    {base::to_underlying(messages::WebNNBuffer::kReadBuffer),
     { &internal::WebNNBuffer_ReadBuffer_Params_Data::Validate,
      &internal::WebNNBuffer_ReadBuffer_ResponseParams_Data::Validate}},
    {base::to_underlying(messages::WebNNBuffer::kWriteBuffer),
     { &internal::WebNNBuffer_WriteBuffer_Params_Data::Validate,
      nullptr /* no response */}},
};

bool WebNNBufferRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNBuffer::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kWebNNBufferValidationInfo);
}

bool WebNNBufferResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNBuffer::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kWebNNBufferValidationInfo);

}


}  // webnn::mojom


namespace mojo {


// static
bool StructTraits<::webnn::mojom::BufferInfo::DataView, ::webnn::mojom::BufferInfoPtr>::Read(
    ::webnn::mojom::BufferInfo::DataView input,
    ::webnn::mojom::BufferInfoPtr* output) {
  bool success = true;
  ::webnn::mojom::BufferInfoPtr result(::webnn::mojom::BufferInfo::New());
  
      if (success)
        result->size = input.size();
  *output = std::move(result);
  return success;
}

// static
bool UnionTraits<::webnn::mojom::ReadBufferResult::DataView, ::webnn::mojom::ReadBufferResultPtr>::Read(
    ::webnn::mojom::ReadBufferResult::DataView input,
    ::webnn::mojom::ReadBufferResultPtr* output) {
  using UnionType = ::webnn::mojom::ReadBufferResult;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kBuffer: {
      ::mojo_base::BigBuffer result_buffer;
      if (!input.ReadBuffer(&result_buffer))
        return false;

      *output = UnionType::NewBuffer(
          std::move(result_buffer));
      break;
    }
    case Tag::kError: {
      ::webnn::mojom::ErrorPtr result_error;
      if (!input.ReadError(&result_error))
        return false;

      *output = UnionType::NewError(
          std::move(result_error));
      break;
    }
    default:

      return false;
  }
  return true;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace webnn::mojom {


void WebNNBufferInterceptorForTesting::ReadBuffer(ReadBufferCallback callback) {
  GetForwardingInterface()->ReadBuffer(std::move(callback));
}
void WebNNBufferInterceptorForTesting::WriteBuffer(::mojo_base::BigBuffer src_buffer) {
  GetForwardingInterface()->WriteBuffer(
    std::move(src_buffer)
    );
}
WebNNBufferAsyncWaiter::WebNNBufferAsyncWaiter(
    WebNNBuffer* proxy) : proxy_(proxy) {}

WebNNBufferAsyncWaiter::~WebNNBufferAsyncWaiter() = default;

void WebNNBufferAsyncWaiter::ReadBuffer(
    ReadBufferResultPtr* out_result) {
  base::RunLoop loop;
  proxy_->ReadBuffer(
      base::BindOnce(
          [](base::RunLoop* loop,
             ReadBufferResultPtr* out_result
,
             ReadBufferResultPtr result) {*out_result = std::move(result);
            loop->Quit();
          },
          &loop,
          out_result));
  loop.Run();
}

ReadBufferResultPtr WebNNBufferAsyncWaiter::ReadBuffer(
    ) {
  ReadBufferResultPtr async_wait_result;
  ReadBuffer(&async_wait_result);
  return async_wait_result;
}






}  // webnn::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif