// third_party/blink/public/mojom/model_execution/model_manager.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_MODEL_EXECUTION_MODEL_MANAGER_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_MODEL_EXECUTION_MODEL_MANAGER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/model_execution/model_manager.mojom-features.h"
#include "third_party/blink/public/mojom/model_execution/model_manager.mojom-shared.h"
#include "third_party/blink/public/mojom/model_execution/model_manager.mojom-forward.h"
#include "third_party/blink/public/mojom/model_execution/model_session.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class ModelManagerProxy;

template <typename ImplRefTraits>
class ModelManagerStub;

class ModelManagerRequestValidator;
class ModelManagerResponseValidator;


class BLINK_COMMON_EXPORT ModelManager
    : public ModelManagerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ModelManagerInterfaceBase;
  using Proxy_ = ModelManagerProxy;

  template <typename ImplRefTraits>
  using Stub_ = ModelManagerStub<ImplRefTraits>;

  using RequestValidator_ = ModelManagerRequestValidator;
  using ResponseValidator_ = ModelManagerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCanCreateGenericSessionMinVersion = 0,
    kCreateGenericSessionMinVersion = 0,
    kGetDefaultGenericSessionSamplingParamsMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CanCreateGenericSession_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateGenericSession_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetDefaultGenericSessionSamplingParams_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ModelManager() = default;


  using CanCreateGenericSessionCallback = base::OnceCallback<void(bool)>;
  
  virtual void CanCreateGenericSession(CanCreateGenericSessionCallback callback) = 0;


  using CreateGenericSessionCallback = base::OnceCallback<void(bool)>;
  
  virtual void CreateGenericSession(::mojo::PendingReceiver<::blink::mojom::ModelGenericSession> session, ModelGenericSessionSamplingParamsPtr sampling_params, CreateGenericSessionCallback callback) = 0;


  using GetDefaultGenericSessionSamplingParamsCallback = base::OnceCallback<void(ModelGenericSessionSamplingParamsPtr)>;
  
  virtual void GetDefaultGenericSessionSamplingParams(GetDefaultGenericSessionSamplingParamsCallback callback) = 0;
};



class BLINK_COMMON_EXPORT ModelManagerProxy
    : public ModelManager {
 public:
  using InterfaceType = ModelManager;

  explicit ModelManagerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CanCreateGenericSession(CanCreateGenericSessionCallback callback) final;
  
  void CreateGenericSession(::mojo::PendingReceiver<::blink::mojom::ModelGenericSession> session, ModelGenericSessionSamplingParamsPtr sampling_params, CreateGenericSessionCallback callback) final;
  
  void GetDefaultGenericSessionSamplingParams(GetDefaultGenericSessionSamplingParamsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT ModelManagerStubDispatch {
 public:
  static bool Accept(ModelManager* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ModelManager* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ModelManager>>
class ModelManagerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ModelManagerStub() = default;
  ~ModelManagerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ModelManagerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ModelManagerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT ModelManagerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT ModelManagerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class BLINK_COMMON_EXPORT ModelGenericSessionSamplingParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ModelGenericSessionSamplingParams, T>::value>;
  using DataView = ModelGenericSessionSamplingParamsDataView;
  using Data_ = internal::ModelGenericSessionSamplingParams_Data;

  template <typename... Args>
  static ModelGenericSessionSamplingParamsPtr New(Args&&... args) {
    return ModelGenericSessionSamplingParamsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ModelGenericSessionSamplingParamsPtr From(const U& u) {
    return mojo::TypeConverter<ModelGenericSessionSamplingParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ModelGenericSessionSamplingParams>::Convert(*this);
  }


  ModelGenericSessionSamplingParams();

  ModelGenericSessionSamplingParams(
      uint32_t top_k,
      float temperature);


  ~ModelGenericSessionSamplingParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ModelGenericSessionSamplingParamsPtr>
  ModelGenericSessionSamplingParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ModelGenericSessionSamplingParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ModelGenericSessionSamplingParams::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ModelGenericSessionSamplingParams::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ModelGenericSessionSamplingParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ModelGenericSessionSamplingParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ModelGenericSessionSamplingParams_UnserializedMessageContext<
            UserType, ModelGenericSessionSamplingParams::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ModelGenericSessionSamplingParams::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ModelGenericSessionSamplingParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ModelGenericSessionSamplingParams_UnserializedMessageContext<
            UserType, ModelGenericSessionSamplingParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ModelGenericSessionSamplingParams::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t top_k;
  
  float temperature;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ModelGenericSessionSamplingParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ModelGenericSessionSamplingParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ModelGenericSessionSamplingParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ModelGenericSessionSamplingParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
ModelGenericSessionSamplingParamsPtr ModelGenericSessionSamplingParams::Clone() const {
  return New(
      mojo::Clone(top_k),
      mojo::Clone(temperature)
  );
}

template <typename T, ModelGenericSessionSamplingParams::EnableIfSame<T>*>
bool ModelGenericSessionSamplingParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->top_k, other_struct.top_k))
    return false;
  if (!mojo::Equals(this->temperature, other_struct.temperature))
    return false;
  return true;
}

template <typename T, ModelGenericSessionSamplingParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.top_k < rhs.top_k)
    return true;
  if (rhs.top_k < lhs.top_k)
    return false;
  if (lhs.temperature < rhs.temperature)
    return true;
  if (rhs.temperature < lhs.temperature)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::ModelGenericSessionSamplingParams::DataView,
                                         ::blink::mojom::ModelGenericSessionSamplingParamsPtr> {
  static bool IsNull(const ::blink::mojom::ModelGenericSessionSamplingParamsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::ModelGenericSessionSamplingParamsPtr* output) { output->reset(); }

  static decltype(::blink::mojom::ModelGenericSessionSamplingParams::top_k) top_k(
      const ::blink::mojom::ModelGenericSessionSamplingParamsPtr& input) {
    return input->top_k;
  }

  static decltype(::blink::mojom::ModelGenericSessionSamplingParams::temperature) temperature(
      const ::blink::mojom::ModelGenericSessionSamplingParamsPtr& input) {
    return input->temperature;
  }

  static bool Read(::blink::mojom::ModelGenericSessionSamplingParams::DataView input, ::blink::mojom::ModelGenericSessionSamplingParamsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_MODEL_EXECUTION_MODEL_MANAGER_MOJOM_H_