// third_party/blink/public/mojom/on_device_translation/translation_manager.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_ON_DEVICE_TRANSLATION_TRANSLATION_MANAGER_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_ON_DEVICE_TRANSLATION_TRANSLATION_MANAGER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/on_device_translation/translation_manager.mojom-features.h"
#include "third_party/blink/public/mojom/on_device_translation/translation_manager.mojom-shared.h"
#include "third_party/blink/public/mojom/on_device_translation/translation_manager.mojom-forward.h"
#include "third_party/blink/public/mojom/on_device_translation/translator.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class TranslationManagerProxy;

template <typename ImplRefTraits>
class TranslationManagerStub;

class TranslationManagerRequestValidator;
class TranslationManagerResponseValidator;


class BLINK_COMMON_EXPORT TranslationManager
    : public TranslationManagerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = TranslationManagerInterfaceBase;
  using Proxy_ = TranslationManagerProxy;

  template <typename ImplRefTraits>
  using Stub_ = TranslationManagerStub<ImplRefTraits>;

  using RequestValidator_ = TranslationManagerRequestValidator;
  using ResponseValidator_ = TranslationManagerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCanCreateTranslatorMinVersion = 0,
    kCreateTranslatorMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CanCreateTranslator_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateTranslator_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~TranslationManager() = default;


  using CanCreateTranslatorCallback = base::OnceCallback<void(bool)>;
  
  virtual void CanCreateTranslator(const std::string& source_lang, const std::string& target_lang, CanCreateTranslatorCallback callback) = 0;


  using CreateTranslatorCallback = base::OnceCallback<void(bool)>;
  
  virtual void CreateTranslator(const std::string& source_lang, const std::string& target_lang, ::mojo::PendingReceiver<::blink::mojom::Translator> receiver, CreateTranslatorCallback callback) = 0;
};



class BLINK_COMMON_EXPORT TranslationManagerProxy
    : public TranslationManager {
 public:
  using InterfaceType = TranslationManager;

  explicit TranslationManagerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CanCreateTranslator(const std::string& source_lang, const std::string& target_lang, CanCreateTranslatorCallback callback) final;
  
  void CreateTranslator(const std::string& source_lang, const std::string& target_lang, ::mojo::PendingReceiver<::blink::mojom::Translator> receiver, CreateTranslatorCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT TranslationManagerStubDispatch {
 public:
  static bool Accept(TranslationManager* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      TranslationManager* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<TranslationManager>>
class TranslationManagerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  TranslationManagerStub() = default;
  ~TranslationManagerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TranslationManagerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TranslationManagerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT TranslationManagerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT TranslationManagerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_ON_DEVICE_TRANSLATION_TRANSLATION_MANAGER_MOJOM_H_