// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_canvas_high_dynamic_range_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_canvas_smpte_st_2086_metadata.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"mode",
"smpteSt2086Metadata",
};


}  // namespace 

CanvasHighDynamicRangeOptions* CanvasHighDynamicRangeOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CanvasHighDynamicRangeOptions* dictionary = MakeGarbageCollected<CanvasHighDynamicRangeOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CanvasHighDynamicRangeOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CanvasHighDynamicRangeOptions::CanvasHighDynamicRangeOptions() {
  
}

 CanvasHighDynamicRangeOptions::CanvasHighDynamicRangeOptions(v8::Isolate* isolate) {
  
}















void CanvasHighDynamicRangeOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8CanvasHighDynamicRangeMode>::Trace(visitor, member_mode_);
TraceIfNeeded<Member<CanvasSmpteSt2086Metadata>>::Trace(visitor, member_smpte_st_2086_metadata_);
bindings::DictionaryBase::Trace(visitor);
}

void CanvasHighDynamicRangeOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void CanvasHighDynamicRangeOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasMode()) {
  values[0] = ToV8Traits<V8CanvasHighDynamicRangeMode>::ToV8(script_state, member_mode_);
DCHECK(!values[0].IsEmpty());
}
if (hasSmpteSt2086Metadata()) {
  values[1] = ToV8Traits<CanvasSmpteSt2086Metadata>::ToV8(script_state, member_smpte_st_2086_metadata_.Get());
DCHECK(!values[1].IsEmpty());
}
}

const void* CanvasHighDynamicRangeOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> CanvasHighDynamicRangeOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void CanvasHighDynamicRangeOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CanvasHighDynamicRangeOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("mode");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8CanvasHighDynamicRangeMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("smpteSt2086Metadata");
if (!bindings::GetDictionaryMemberFromV8Object<CanvasSmpteSt2086Metadata, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_smpte_st_2086_metadata_, member_smpte_st_2086_metadata_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> CanvasHighDynamicRangeOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
