// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_dom_matrix_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"is2D",
"m13",
"m14",
"m23",
"m24",
"m31",
"m32",
"m33",
"m34",
"m43",
"m44",
};


}  // namespace 

DOMMatrixInit* DOMMatrixInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DOMMatrixInit* dictionary = MakeGarbageCollected<DOMMatrixInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DOMMatrixInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 DOMMatrixInit::DOMMatrixInit() {
  
}

 DOMMatrixInit::DOMMatrixInit(v8::Isolate* isolate) : DOMMatrix2DInit(isolate) {
  
}




























































void DOMMatrixInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_is_2d_);
TraceIfNeeded<double>::Trace(visitor, member_m_13_);
TraceIfNeeded<double>::Trace(visitor, member_m_14_);
TraceIfNeeded<double>::Trace(visitor, member_m_23_);
TraceIfNeeded<double>::Trace(visitor, member_m_24_);
TraceIfNeeded<double>::Trace(visitor, member_m_31_);
TraceIfNeeded<double>::Trace(visitor, member_m_32_);
TraceIfNeeded<double>::Trace(visitor, member_m_33_);
TraceIfNeeded<double>::Trace(visitor, member_m_34_);
TraceIfNeeded<double>::Trace(visitor, member_m_43_);
TraceIfNeeded<double>::Trace(visitor, member_m_44_);
DOMMatrix2DInit::Trace(visitor);
}

void DOMMatrixInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  DOMMatrix2DInit::FillTemplateProperties(properties);
DCHECK_EQ(properties.size(), kBasePropertyCount);

static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void DOMMatrixInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  DOMMatrix2DInit::FillValuesImpl(script_state, values.first(kBasePropertyCount));
values = values.subspan(kBasePropertyCount);

CHECK_EQ(kOwnPropertyCount, values.size());
if (hasIs2D()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_is_2d_);
DCHECK(!values[0].IsEmpty());
}
if (hasM13()) {
  values[1] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_13_);
DCHECK(!values[1].IsEmpty());
}
if (hasM14()) {
  values[2] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_14_);
DCHECK(!values[2].IsEmpty());
}
if (hasM23()) {
  values[3] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_23_);
DCHECK(!values[3].IsEmpty());
}
if (hasM24()) {
  values[4] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_24_);
DCHECK(!values[4].IsEmpty());
}
if (hasM31()) {
  values[5] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_31_);
DCHECK(!values[5].IsEmpty());
}
if (hasM32()) {
  values[6] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_32_);
DCHECK(!values[6].IsEmpty());
}
if (hasM33()) {
  values[7] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_33_);
DCHECK(!values[7].IsEmpty());
}
if (hasM34()) {
  values[8] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_34_);
DCHECK(!values[8].IsEmpty());
}
if (hasM43()) {
  values[9] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_43_);
DCHECK(!values[9].IsEmpty());
}
if (hasM44()) {
  values[10] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_44_);
DCHECK(!values[10].IsEmpty());
}
}

const void* DOMMatrixInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> DOMMatrixInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void DOMMatrixInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  DOMMatrix2DInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "DOMMatrixInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("is2D");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_is_2d_, member_is_2d_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m13");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_m_13_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m14");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_m_14_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m23");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_m_23_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m24");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_m_24_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m31");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_m_31_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m32");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_m_32_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m33");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_m_33_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m34");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_m_34_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m43");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_m_43_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m44");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), fallback_presence_var, member_m_44_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DOMMatrixInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
