// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_keyboard_event_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"charCode",
"code",
"isComposing",
"key",
"keyCode",
"location",
"repeat",
};


}  // namespace 

KeyboardEventInit* KeyboardEventInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  KeyboardEventInit* dictionary = MakeGarbageCollected<KeyboardEventInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "KeyboardEventInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 KeyboardEventInit::KeyboardEventInit() {
  
}

 KeyboardEventInit::KeyboardEventInit(v8::Isolate* isolate) : EventModifierInit(isolate) {
  
}








void KeyboardEventInit::setCode(const String& value) {
  member_code_ = value;
}

void KeyboardEventInit::setCode(String&& value) {
  member_code_ = std::move(value);
}









void KeyboardEventInit::setKey(const String& value) {
  member_key_ = value;
}

void KeyboardEventInit::setKey(String&& value) {
  member_key_ = std::move(value);
}



















void KeyboardEventInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_char_code_);
TraceIfNeeded<String>::Trace(visitor, member_code_);
TraceIfNeeded<bool>::Trace(visitor, member_is_composing_);
TraceIfNeeded<String>::Trace(visitor, member_key_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_key_code_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_location_);
TraceIfNeeded<bool>::Trace(visitor, member_repeat_);
EventModifierInit::Trace(visitor);
}

void KeyboardEventInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  EventModifierInit::FillTemplateProperties(properties);
DCHECK_EQ(properties.size(), kBasePropertyCount);

static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void KeyboardEventInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  EventModifierInit::FillValuesImpl(script_state, values.first(kBasePropertyCount));
values = values.subspan(kBasePropertyCount);

CHECK_EQ(kOwnPropertyCount, values.size());
if (hasCharCode()) {
  values[0] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_char_code_);
DCHECK(!values[0].IsEmpty());
}
if (hasCode()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_code_);
DCHECK(!values[1].IsEmpty());
}
if (hasIsComposing()) {
  values[2] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_is_composing_);
DCHECK(!values[2].IsEmpty());
}
if (hasKey()) {
  values[3] = ToV8Traits<IDLString>::ToV8(script_state, member_key_);
DCHECK(!values[3].IsEmpty());
}
if (hasKeyCode()) {
  values[4] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_key_code_);
DCHECK(!values[4].IsEmpty());
}
if (hasLocation()) {
  values[5] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_location_);
DCHECK(!values[5].IsEmpty());
}
if (hasRepeat()) {
  values[6] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_repeat_);
DCHECK(!values[6].IsEmpty());
}
}

const void* KeyboardEventInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> KeyboardEventInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void KeyboardEventInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  EventModifierInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "KeyboardEventInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("charCode");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_char_code_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("code");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_code_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("isComposing");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_is_composing_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("key");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_key_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("keyCode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_key_code_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("location");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_location_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("repeat");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_repeat_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> KeyboardEventInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
