// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_navigation_intercept_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_navigation_intercept_handler.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"commit",
"focusReset",
"handler",
"scroll",
};


}  // namespace 

NavigationInterceptOptions* NavigationInterceptOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  NavigationInterceptOptions* dictionary = MakeGarbageCollected<NavigationInterceptOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "NavigationInterceptOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 NavigationInterceptOptions::NavigationInterceptOptions() {
  
}

 NavigationInterceptOptions::NavigationInterceptOptions(v8::Isolate* isolate) {
  
}































void NavigationInterceptOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8NavigationCommitBehavior>::Trace(visitor, member_commit_);
TraceIfNeeded<V8NavigationFocusReset>::Trace(visitor, member_focus_reset_);
TraceIfNeeded<Member<V8NavigationInterceptHandler>>::Trace(visitor, member_handler_);
TraceIfNeeded<V8NavigationScrollBehavior>::Trace(visitor, member_scroll_);
bindings::DictionaryBase::Trace(visitor);
}

void NavigationInterceptOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void NavigationInterceptOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasCommit()) {
  values[0] = ToV8Traits<V8NavigationCommitBehavior>::ToV8(script_state, member_commit_);
DCHECK(!values[0].IsEmpty());
}
if (hasFocusReset()) {
  values[1] = ToV8Traits<V8NavigationFocusReset>::ToV8(script_state, member_focus_reset_);
DCHECK(!values[1].IsEmpty());
}
if (hasHandler()) {
  values[2] = ToV8Traits<V8NavigationInterceptHandler>::ToV8(script_state, member_handler_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasScroll()) {
  values[3] = ToV8Traits<V8NavigationScrollBehavior>::ToV8(script_state, member_scroll_);
DCHECK(!values[3].IsEmpty());
}
}

const void* NavigationInterceptOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> NavigationInterceptOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void NavigationInterceptOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "NavigationInterceptOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("commit");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8NavigationCommitBehavior, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_commit_, member_commit_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("focusReset");
if (!bindings::GetDictionaryMemberFromV8Object<V8NavigationFocusReset, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_focus_reset_, member_focus_reset_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("handler");
if (!bindings::GetDictionaryMemberFromV8Object<V8NavigationInterceptHandler, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_handler_, member_handler_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("scroll");
if (!bindings::GetDictionaryMemberFromV8Object<V8NavigationScrollBehavior, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_scroll_, member_scroll_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> NavigationInterceptOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
