// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_performance_measure_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_double_string.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"detail",
"duration",
"end",
"start",
};


}  // namespace 

PerformanceMeasureOptions* PerformanceMeasureOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PerformanceMeasureOptions* dictionary = MakeGarbageCollected<PerformanceMeasureOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PerformanceMeasureOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 PerformanceMeasureOptions::PerformanceMeasureOptions() {
  
}

 PerformanceMeasureOptions::PerformanceMeasureOptions(v8::Isolate* isolate) {
  
}































void PerformanceMeasureOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<ScriptValue>::Trace(visitor, member_detail_);
TraceIfNeeded<double>::Trace(visitor, member_duration_);
TraceIfNeeded<Member<V8UnionDoubleOrString>>::Trace(visitor, member_end_);
TraceIfNeeded<Member<V8UnionDoubleOrString>>::Trace(visitor, member_start_);
bindings::DictionaryBase::Trace(visitor);
}

void PerformanceMeasureOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void PerformanceMeasureOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasDetail()) {
  values[0] = ToV8Traits<IDLAny>::ToV8(script_state, member_detail_);
DCHECK(!values[0].IsEmpty());
}
if (hasDuration()) {
  values[1] = ToV8Traits<IDLDouble>::ToV8(script_state, member_duration_);
DCHECK(!values[1].IsEmpty());
}
if (hasEnd()) {
  values[2] = ToV8Traits<V8UnionDoubleOrString>::ToV8(script_state, member_end_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasStart()) {
  values[3] = ToV8Traits<V8UnionDoubleOrString>::ToV8(script_state, member_start_.Get());
DCHECK(!values[3].IsEmpty());
}
}

const void* PerformanceMeasureOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> PerformanceMeasureOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void PerformanceMeasureOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "PerformanceMeasureOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("detail");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLAny, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_detail_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("duration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_duration_, member_duration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("end");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionDoubleOrString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_end_, member_end_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("start");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionDoubleOrString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_start_, member_start_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PerformanceMeasureOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
