// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_ad_config.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_ad_config.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_ad_interest_group_size.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_real_time_reporting_config.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_report_buyer_debug_mode_config.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_report_buyers_config.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_protected_audience_private_aggregation_config.h"
#include "third_party/blink/renderer/core/dom/abort_signal.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"additionalBids",
"allSlotsRequestedSizes",
"auctionNonce",
"auctionReportBuyerDebugModeConfig",
"auctionReportBuyerKeys",
"auctionReportBuyers",
"auctionSignals",
"componentAuctions",
"decisionLogicURL",
"decisionLogicUrl",
"deprecatedRenderURLReplacements",
"directFromSellerSignals",
"directFromSellerSignalsHeaderAdSlot",
"interestGroupBuyers",
"maxTrustedScoringSignalsURLLength",
"perBuyerCumulativeTimeouts",
"perBuyerCurrencies",
"perBuyerExperimentGroupIds",
"perBuyerGroupLimits",
"perBuyerMultiBidLimits",
"perBuyerPrioritySignals",
"perBuyerRealTimeReportingConfig",
"perBuyerSignals",
"perBuyerTimeouts",
"privateAggregationConfig",
"reportingTimeout",
"requestId",
"requestedSize",
"requiredSellerCapabilities",
"resolveToConfig",
"seller",
"sellerCurrency",
"sellerExperimentGroupId",
"sellerRealTimeReportingConfig",
"sellerSignals",
"sellerTimeout",
"serverResponse",
"signal",
"trustedScoringSignalsURL",
"trustedScoringSignalsUrl",
};


}  // namespace 

AuctionAdConfig* AuctionAdConfig::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuctionAdConfig* dictionary = MakeGarbageCollected<AuctionAdConfig>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuctionAdConfig";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuctionAdConfig::AuctionAdConfig() {
  
}

 AuctionAdConfig::AuctionAdConfig(v8::Isolate* isolate) {
  
}










HeapVector<Member<AuctionAdInterestGroupSize>> AuctionAdConfig::getAllSlotsRequestedSizesOr(const HeapVector<Member<AuctionAdInterestGroupSize>>& fallback_value) const {
  if (!hasAllSlotsRequestedSizes()) {
  return fallback_value;
}
return member_all_slots_requested_sizes_;
}

HeapVector<Member<AuctionAdInterestGroupSize>> AuctionAdConfig::getAllSlotsRequestedSizesOr(HeapVector<Member<AuctionAdInterestGroupSize>>&& fallback_value) const {
  if (!hasAllSlotsRequestedSizes()) {
  return std::move(fallback_value);
}
return member_all_slots_requested_sizes_;
}

void AuctionAdConfig::setAllSlotsRequestedSizes(const HeapVector<Member<AuctionAdInterestGroupSize>>& value) {
  member_all_slots_requested_sizes_ = value;
has_all_slots_requested_sizes_ = true;
}

void AuctionAdConfig::setAllSlotsRequestedSizes(HeapVector<Member<AuctionAdInterestGroupSize>>&& value) {
  member_all_slots_requested_sizes_ = std::move(value);
has_all_slots_requested_sizes_ = true;
}




String AuctionAdConfig::getAuctionNonceOr(const String& fallback_value) const {
  if (!hasAuctionNonce()) {
  return fallback_value;
}
return member_auction_nonce_;
}

String AuctionAdConfig::getAuctionNonceOr(String&& fallback_value) const {
  if (!hasAuctionNonce()) {
  return std::move(fallback_value);
}
return member_auction_nonce_;
}

void AuctionAdConfig::setAuctionNonce(const String& value) {
  member_auction_nonce_ = value;
has_auction_nonce_ = true;
}

void AuctionAdConfig::setAuctionNonce(String&& value) {
  member_auction_nonce_ = std::move(value);
has_auction_nonce_ = true;
}











Vector<BigInt> AuctionAdConfig::getAuctionReportBuyerKeysOr(const Vector<BigInt>& fallback_value) const {
  if (!hasAuctionReportBuyerKeys()) {
  return fallback_value;
}
return member_auction_report_buyer_keys_;
}

Vector<BigInt> AuctionAdConfig::getAuctionReportBuyerKeysOr(Vector<BigInt>&& fallback_value) const {
  if (!hasAuctionReportBuyerKeys()) {
  return std::move(fallback_value);
}
return member_auction_report_buyer_keys_;
}

void AuctionAdConfig::setAuctionReportBuyerKeys(const Vector<BigInt>& value) {
  member_auction_report_buyer_keys_ = value;
has_auction_report_buyer_keys_ = true;
}

void AuctionAdConfig::setAuctionReportBuyerKeys(Vector<BigInt>&& value) {
  member_auction_report_buyer_keys_ = std::move(value);
has_auction_report_buyer_keys_ = true;
}




HeapVector<std::pair<String, Member<AuctionReportBuyersConfig>>> AuctionAdConfig::getAuctionReportBuyersOr(const HeapVector<std::pair<String, Member<AuctionReportBuyersConfig>>>& fallback_value) const {
  if (!hasAuctionReportBuyers()) {
  return fallback_value;
}
return member_auction_report_buyers_;
}

HeapVector<std::pair<String, Member<AuctionReportBuyersConfig>>> AuctionAdConfig::getAuctionReportBuyersOr(HeapVector<std::pair<String, Member<AuctionReportBuyersConfig>>>&& fallback_value) const {
  if (!hasAuctionReportBuyers()) {
  return std::move(fallback_value);
}
return member_auction_report_buyers_;
}

void AuctionAdConfig::setAuctionReportBuyers(const HeapVector<std::pair<String, Member<AuctionReportBuyersConfig>>>& value) {
  member_auction_report_buyers_ = value;
has_auction_report_buyers_ = true;
}

void AuctionAdConfig::setAuctionReportBuyers(HeapVector<std::pair<String, Member<AuctionReportBuyersConfig>>>&& value) {
  member_auction_report_buyers_ = std::move(value);
has_auction_report_buyers_ = true;
}











HeapVector<Member<AuctionAdConfig>> AuctionAdConfig::getComponentAuctionsOr(const HeapVector<Member<AuctionAdConfig>>& fallback_value) const {
  if (!hasComponentAuctions()) {
  return fallback_value;
}
return member_component_auctions_;
}

HeapVector<Member<AuctionAdConfig>> AuctionAdConfig::getComponentAuctionsOr(HeapVector<Member<AuctionAdConfig>>&& fallback_value) const {
  if (!hasComponentAuctions()) {
  return std::move(fallback_value);
}
return member_component_auctions_;
}

void AuctionAdConfig::setComponentAuctions(const HeapVector<Member<AuctionAdConfig>>& value) {
  member_component_auctions_ = value;
has_component_auctions_ = true;
}

void AuctionAdConfig::setComponentAuctions(HeapVector<Member<AuctionAdConfig>>&& value) {
  member_component_auctions_ = std::move(value);
has_component_auctions_ = true;
}




String AuctionAdConfig::getDecisionLogicURLOr(const String& fallback_value) const {
  if (!hasDecisionLogicURL()) {
  return fallback_value;
}
return member_decision_logic_url_;
}

String AuctionAdConfig::getDecisionLogicURLOr(String&& fallback_value) const {
  if (!hasDecisionLogicURL()) {
  return std::move(fallback_value);
}
return member_decision_logic_url_;
}

void AuctionAdConfig::setDecisionLogicURL(const String& value) {
  member_decision_logic_url_ = value;
has_decision_logic_url_ = true;
}

void AuctionAdConfig::setDecisionLogicURL(String&& value) {
  member_decision_logic_url_ = std::move(value);
has_decision_logic_url_ = true;
}




String AuctionAdConfig::getDecisionLogicUrlDeprecatedOr(const String& fallback_value) const {
  if (!hasDecisionLogicUrlDeprecated()) {
  return fallback_value;
}
return member_decision_logic_url_deprecated_;
}

String AuctionAdConfig::getDecisionLogicUrlDeprecatedOr(String&& fallback_value) const {
  if (!hasDecisionLogicUrlDeprecated()) {
  return std::move(fallback_value);
}
return member_decision_logic_url_deprecated_;
}

void AuctionAdConfig::setDecisionLogicUrlDeprecated(const String& value) {
  member_decision_logic_url_deprecated_ = value;
has_decision_logic_url_deprecated_ = true;
}

void AuctionAdConfig::setDecisionLogicUrlDeprecated(String&& value) {
  member_decision_logic_url_deprecated_ = std::move(value);
has_decision_logic_url_deprecated_ = true;
}

























Vector<String> AuctionAdConfig::getInterestGroupBuyersOr(const Vector<String>& fallback_value) const {
  if (!hasInterestGroupBuyers()) {
  return fallback_value;
}
return member_interest_group_buyers_;
}

Vector<String> AuctionAdConfig::getInterestGroupBuyersOr(Vector<String>&& fallback_value) const {
  if (!hasInterestGroupBuyers()) {
  return std::move(fallback_value);
}
return member_interest_group_buyers_;
}

void AuctionAdConfig::setInterestGroupBuyers(const Vector<String>& value) {
  member_interest_group_buyers_ = value;
has_interest_group_buyers_ = true;
}

void AuctionAdConfig::setInterestGroupBuyers(Vector<String>&& value) {
  member_interest_group_buyers_ = std::move(value);
has_interest_group_buyers_ = true;
}

























Vector<std::pair<String, uint16_t>> AuctionAdConfig::getPerBuyerExperimentGroupIdsOr(const Vector<std::pair<String, uint16_t>>& fallback_value) const {
  if (!hasPerBuyerExperimentGroupIds()) {
  return fallback_value;
}
return member_per_buyer_experiment_group_ids_;
}

Vector<std::pair<String, uint16_t>> AuctionAdConfig::getPerBuyerExperimentGroupIdsOr(Vector<std::pair<String, uint16_t>>&& fallback_value) const {
  if (!hasPerBuyerExperimentGroupIds()) {
  return std::move(fallback_value);
}
return member_per_buyer_experiment_group_ids_;
}

void AuctionAdConfig::setPerBuyerExperimentGroupIds(const Vector<std::pair<String, uint16_t>>& value) {
  member_per_buyer_experiment_group_ids_ = value;
has_per_buyer_experiment_group_ids_ = true;
}

void AuctionAdConfig::setPerBuyerExperimentGroupIds(Vector<std::pair<String, uint16_t>>&& value) {
  member_per_buyer_experiment_group_ids_ = std::move(value);
has_per_buyer_experiment_group_ids_ = true;
}




Vector<std::pair<String, uint16_t>> AuctionAdConfig::getPerBuyerGroupLimitsOr(const Vector<std::pair<String, uint16_t>>& fallback_value) const {
  if (!hasPerBuyerGroupLimits()) {
  return fallback_value;
}
return member_per_buyer_group_limits_;
}

Vector<std::pair<String, uint16_t>> AuctionAdConfig::getPerBuyerGroupLimitsOr(Vector<std::pair<String, uint16_t>>&& fallback_value) const {
  if (!hasPerBuyerGroupLimits()) {
  return std::move(fallback_value);
}
return member_per_buyer_group_limits_;
}

void AuctionAdConfig::setPerBuyerGroupLimits(const Vector<std::pair<String, uint16_t>>& value) {
  member_per_buyer_group_limits_ = value;
has_per_buyer_group_limits_ = true;
}

void AuctionAdConfig::setPerBuyerGroupLimits(Vector<std::pair<String, uint16_t>>&& value) {
  member_per_buyer_group_limits_ = std::move(value);
has_per_buyer_group_limits_ = true;
}




Vector<std::pair<String, uint16_t>> AuctionAdConfig::getPerBuyerMultiBidLimitsOr(const Vector<std::pair<String, uint16_t>>& fallback_value) const {
  if (!hasPerBuyerMultiBidLimits()) {
  return fallback_value;
}
return member_per_buyer_multi_bid_limits_;
}

Vector<std::pair<String, uint16_t>> AuctionAdConfig::getPerBuyerMultiBidLimitsOr(Vector<std::pair<String, uint16_t>>&& fallback_value) const {
  if (!hasPerBuyerMultiBidLimits()) {
  return std::move(fallback_value);
}
return member_per_buyer_multi_bid_limits_;
}

void AuctionAdConfig::setPerBuyerMultiBidLimits(const Vector<std::pair<String, uint16_t>>& value) {
  member_per_buyer_multi_bid_limits_ = value;
has_per_buyer_multi_bid_limits_ = true;
}

void AuctionAdConfig::setPerBuyerMultiBidLimits(Vector<std::pair<String, uint16_t>>&& value) {
  member_per_buyer_multi_bid_limits_ = std::move(value);
has_per_buyer_multi_bid_limits_ = true;
}




Vector<std::pair<String, Vector<std::pair<String, double>>>> AuctionAdConfig::getPerBuyerPrioritySignalsOr(const Vector<std::pair<String, Vector<std::pair<String, double>>>>& fallback_value) const {
  if (!hasPerBuyerPrioritySignals()) {
  return fallback_value;
}
return member_per_buyer_priority_signals_;
}

Vector<std::pair<String, Vector<std::pair<String, double>>>> AuctionAdConfig::getPerBuyerPrioritySignalsOr(Vector<std::pair<String, Vector<std::pair<String, double>>>>&& fallback_value) const {
  if (!hasPerBuyerPrioritySignals()) {
  return std::move(fallback_value);
}
return member_per_buyer_priority_signals_;
}

void AuctionAdConfig::setPerBuyerPrioritySignals(const Vector<std::pair<String, Vector<std::pair<String, double>>>>& value) {
  member_per_buyer_priority_signals_ = value;
has_per_buyer_priority_signals_ = true;
}

void AuctionAdConfig::setPerBuyerPrioritySignals(Vector<std::pair<String, Vector<std::pair<String, double>>>>&& value) {
  member_per_buyer_priority_signals_ = std::move(value);
has_per_buyer_priority_signals_ = true;
}




HeapVector<std::pair<String, Member<AuctionRealTimeReportingConfig>>> AuctionAdConfig::getPerBuyerRealTimeReportingConfigOr(const HeapVector<std::pair<String, Member<AuctionRealTimeReportingConfig>>>& fallback_value) const {
  if (!hasPerBuyerRealTimeReportingConfig()) {
  return fallback_value;
}
return member_per_buyer_real_time_reporting_config_;
}

HeapVector<std::pair<String, Member<AuctionRealTimeReportingConfig>>> AuctionAdConfig::getPerBuyerRealTimeReportingConfigOr(HeapVector<std::pair<String, Member<AuctionRealTimeReportingConfig>>>&& fallback_value) const {
  if (!hasPerBuyerRealTimeReportingConfig()) {
  return std::move(fallback_value);
}
return member_per_buyer_real_time_reporting_config_;
}

void AuctionAdConfig::setPerBuyerRealTimeReportingConfig(const HeapVector<std::pair<String, Member<AuctionRealTimeReportingConfig>>>& value) {
  member_per_buyer_real_time_reporting_config_ = value;
has_per_buyer_real_time_reporting_config_ = true;
}

void AuctionAdConfig::setPerBuyerRealTimeReportingConfig(HeapVector<std::pair<String, Member<AuctionRealTimeReportingConfig>>>&& value) {
  member_per_buyer_real_time_reporting_config_ = std::move(value);
has_per_buyer_real_time_reporting_config_ = true;
}
































String AuctionAdConfig::getRequestIdOr(const String& fallback_value) const {
  if (!hasRequestId()) {
  return fallback_value;
}
return member_request_id_;
}

String AuctionAdConfig::getRequestIdOr(String&& fallback_value) const {
  if (!hasRequestId()) {
  return std::move(fallback_value);
}
return member_request_id_;
}

void AuctionAdConfig::setRequestId(const String& value) {
  member_request_id_ = value;
has_request_id_ = true;
}

void AuctionAdConfig::setRequestId(String&& value) {
  member_request_id_ = std::move(value);
has_request_id_ = true;
}











Vector<String> AuctionAdConfig::getRequiredSellerCapabilitiesOr(const Vector<String>& fallback_value) const {
  if (!hasRequiredSellerCapabilities()) {
  return fallback_value;
}
return member_required_seller_capabilities_;
}

Vector<String> AuctionAdConfig::getRequiredSellerCapabilitiesOr(Vector<String>&& fallback_value) const {
  if (!hasRequiredSellerCapabilities()) {
  return std::move(fallback_value);
}
return member_required_seller_capabilities_;
}

void AuctionAdConfig::setRequiredSellerCapabilities(const Vector<String>& value) {
  member_required_seller_capabilities_ = value;
has_required_seller_capabilities_ = true;
}

void AuctionAdConfig::setRequiredSellerCapabilities(Vector<String>&& value) {
  member_required_seller_capabilities_ = std::move(value);
has_required_seller_capabilities_ = true;
}











void AuctionAdConfig::setSeller(const String& value) {
  member_seller_ = value;
}

void AuctionAdConfig::setSeller(String&& value) {
  member_seller_ = std::move(value);
}




String AuctionAdConfig::getSellerCurrencyOr(const String& fallback_value) const {
  if (!hasSellerCurrency()) {
  return fallback_value;
}
return member_seller_currency_;
}

String AuctionAdConfig::getSellerCurrencyOr(String&& fallback_value) const {
  if (!hasSellerCurrency()) {
  return std::move(fallback_value);
}
return member_seller_currency_;
}

void AuctionAdConfig::setSellerCurrency(const String& value) {
  member_seller_currency_ = value;
has_seller_currency_ = true;
}

void AuctionAdConfig::setSellerCurrency(String&& value) {
  member_seller_currency_ = std::move(value);
has_seller_currency_ = true;
}














































String AuctionAdConfig::getTrustedScoringSignalsURLOr(const String& fallback_value) const {
  if (!hasTrustedScoringSignalsURL()) {
  return fallback_value;
}
return member_trusted_scoring_signals_url_;
}

String AuctionAdConfig::getTrustedScoringSignalsURLOr(String&& fallback_value) const {
  if (!hasTrustedScoringSignalsURL()) {
  return std::move(fallback_value);
}
return member_trusted_scoring_signals_url_;
}

void AuctionAdConfig::setTrustedScoringSignalsURL(const String& value) {
  member_trusted_scoring_signals_url_ = value;
has_trusted_scoring_signals_url_ = true;
}

void AuctionAdConfig::setTrustedScoringSignalsURL(String&& value) {
  member_trusted_scoring_signals_url_ = std::move(value);
has_trusted_scoring_signals_url_ = true;
}




String AuctionAdConfig::getTrustedScoringSignalsUrlDeprecatedOr(const String& fallback_value) const {
  if (!hasTrustedScoringSignalsUrlDeprecated()) {
  return fallback_value;
}
return member_trusted_scoring_signals_url_deprecated_;
}

String AuctionAdConfig::getTrustedScoringSignalsUrlDeprecatedOr(String&& fallback_value) const {
  if (!hasTrustedScoringSignalsUrlDeprecated()) {
  return std::move(fallback_value);
}
return member_trusted_scoring_signals_url_deprecated_;
}

void AuctionAdConfig::setTrustedScoringSignalsUrlDeprecated(const String& value) {
  member_trusted_scoring_signals_url_deprecated_ = value;
has_trusted_scoring_signals_url_deprecated_ = true;
}

void AuctionAdConfig::setTrustedScoringSignalsUrlDeprecated(String&& value) {
  member_trusted_scoring_signals_url_deprecated_ = std::move(value);
has_trusted_scoring_signals_url_deprecated_ = true;
}




void AuctionAdConfig::Trace(Visitor* visitor) const {
  TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_additional_bids_);
TraceIfNeeded<HeapVector<Member<AuctionAdInterestGroupSize>>>::Trace(visitor, member_all_slots_requested_sizes_);
TraceIfNeeded<String>::Trace(visitor, member_auction_nonce_);
TraceIfNeeded<Member<AuctionReportBuyerDebugModeConfig>>::Trace(visitor, member_auction_report_buyer_debug_mode_config_);
TraceIfNeeded<Vector<BigInt>>::Trace(visitor, member_auction_report_buyer_keys_);
TraceIfNeeded<HeapVector<std::pair<String, Member<AuctionReportBuyersConfig>>>>::Trace(visitor, member_auction_report_buyers_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_auction_signals_);
TraceIfNeeded<HeapVector<Member<AuctionAdConfig>>>::Trace(visitor, member_component_auctions_);
TraceIfNeeded<String>::Trace(visitor, member_decision_logic_url_);
TraceIfNeeded<String>::Trace(visitor, member_decision_logic_url_deprecated_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_deprecated_render_url_replacements_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_direct_from_seller_signals_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_direct_from_seller_signals_header_ad_slot_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_interest_group_buyers_);
TraceIfNeeded<int32_t>::Trace(visitor, member_max_trusted_scoring_signals_url_length_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_per_buyer_cumulative_timeouts_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_per_buyer_currencies_);
TraceIfNeeded<Vector<std::pair<String, uint16_t>>>::Trace(visitor, member_per_buyer_experiment_group_ids_);
TraceIfNeeded<Vector<std::pair<String, uint16_t>>>::Trace(visitor, member_per_buyer_group_limits_);
TraceIfNeeded<Vector<std::pair<String, uint16_t>>>::Trace(visitor, member_per_buyer_multi_bid_limits_);
TraceIfNeeded<Vector<std::pair<String, Vector<std::pair<String, double>>>>>::Trace(visitor, member_per_buyer_priority_signals_);
TraceIfNeeded<HeapVector<std::pair<String, Member<AuctionRealTimeReportingConfig>>>>::Trace(visitor, member_per_buyer_real_time_reporting_config_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_per_buyer_signals_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_per_buyer_timeouts_);
TraceIfNeeded<Member<ProtectedAudiencePrivateAggregationConfig>>::Trace(visitor, member_private_aggregation_config_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_reporting_timeout_);
TraceIfNeeded<String>::Trace(visitor, member_request_id_);
TraceIfNeeded<Member<AuctionAdInterestGroupSize>>::Trace(visitor, member_requested_size_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_required_seller_capabilities_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_resolve_to_config_);
TraceIfNeeded<String>::Trace(visitor, member_seller_);
TraceIfNeeded<String>::Trace(visitor, member_seller_currency_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_seller_experiment_group_id_);
TraceIfNeeded<Member<AuctionRealTimeReportingConfig>>::Trace(visitor, member_seller_real_time_reporting_config_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_seller_signals_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_seller_timeout_);
TraceIfNeeded<ScriptPromiseUntyped>::Trace(visitor, member_server_response_);
TraceIfNeeded<Member<AbortSignal>>::Trace(visitor, member_signal_);
TraceIfNeeded<String>::Trace(visitor, member_trusted_scoring_signals_url_);
TraceIfNeeded<String>::Trace(visitor, member_trusted_scoring_signals_url_deprecated_);
bindings::DictionaryBase::Trace(visitor);
}

void AuctionAdConfig::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void AuctionAdConfig::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (RuntimeEnabledFeatures::FledgeNegativeTargetingEnabled()) {
  if (hasAdditionalBids()) {
  values[0] = ToV8Traits<IDLPromise>::ToV8(script_state, member_additional_bids_);
DCHECK(!values[0].IsEmpty());
}
}
if (RuntimeEnabledFeatures::FledgeTrustedBiddingSignalsSlotSizeEnabled()) {
  if (hasAllSlotsRequestedSizes()) {
  values[1] = ToV8Traits<IDLSequence<AuctionAdInterestGroupSize>>::ToV8(script_state, member_all_slots_requested_sizes_);
DCHECK(!values[1].IsEmpty());
}
}
if (RuntimeEnabledFeatures::FledgeNegativeTargetingEnabled()) {
  if (hasAuctionNonce()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_auction_nonce_);
DCHECK(!values[2].IsEmpty());
}
}
if (RuntimeEnabledFeatures::PrivateAggregationAuctionReportBuyerDebugModeConfigEnabled()) {
  if (hasAuctionReportBuyerDebugModeConfig()) {
  values[3] = ToV8Traits<AuctionReportBuyerDebugModeConfig>::ToV8(script_state, member_auction_report_buyer_debug_mode_config_.Get());
DCHECK(!values[3].IsEmpty());
}
}
if (hasAuctionReportBuyerKeys()) {
  values[4] = ToV8Traits<IDLSequence<IDLBigint>>::ToV8(script_state, member_auction_report_buyer_keys_);
DCHECK(!values[4].IsEmpty());
}
if (hasAuctionReportBuyers()) {
  values[5] = ToV8Traits<IDLRecord<IDLString, AuctionReportBuyersConfig>>::ToV8(script_state, member_auction_report_buyers_);
DCHECK(!values[5].IsEmpty());
}
if (hasAuctionSignals()) {
  values[6] = ToV8Traits<IDLPromise>::ToV8(script_state, member_auction_signals_);
DCHECK(!values[6].IsEmpty());
}
if (hasComponentAuctions()) {
  values[7] = ToV8Traits<IDLSequence<AuctionAdConfig>>::ToV8(script_state, member_component_auctions_);
DCHECK(!values[7].IsEmpty());
}
if (hasDecisionLogicURL()) {
  values[8] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_decision_logic_url_);
DCHECK(!values[8].IsEmpty());
}
if (hasDecisionLogicUrlDeprecated()) {
  values[9] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_decision_logic_url_deprecated_);
DCHECK(!values[9].IsEmpty());
}
if (RuntimeEnabledFeatures::FledgeDeprecatedRenderURLReplacementsEnabled()) {
  if (hasDeprecatedRenderURLReplacements()) {
  values[10] = ToV8Traits<IDLPromise>::ToV8(script_state, member_deprecated_render_url_replacements_);
DCHECK(!values[10].IsEmpty());
}
}
if (hasDirectFromSellerSignals()) {
  values[11] = ToV8Traits<IDLPromise>::ToV8(script_state, member_direct_from_seller_signals_);
DCHECK(!values[11].IsEmpty());
}
if (RuntimeEnabledFeatures::FledgeDirectFromSellerSignalsHeaderAdSlotEnabled()) {
  if (hasDirectFromSellerSignalsHeaderAdSlot()) {
  values[12] = ToV8Traits<IDLPromise>::ToV8(script_state, member_direct_from_seller_signals_header_ad_slot_);
DCHECK(!values[12].IsEmpty());
}
}
if (hasInterestGroupBuyers()) {
  values[13] = ToV8Traits<IDLSequence<IDLUSVString>>::ToV8(script_state, member_interest_group_buyers_);
DCHECK(!values[13].IsEmpty());
}
if (hasMaxTrustedScoringSignalsURLLength()) {
  values[14] = ToV8Traits<IDLLong>::ToV8(script_state, member_max_trusted_scoring_signals_url_length_);
DCHECK(!values[14].IsEmpty());
}
if (hasPerBuyerCumulativeTimeouts()) {
  values[15] = ToV8Traits<IDLPromise>::ToV8(script_state, member_per_buyer_cumulative_timeouts_);
DCHECK(!values[15].IsEmpty());
}
if (hasPerBuyerCurrencies()) {
  values[16] = ToV8Traits<IDLPromise>::ToV8(script_state, member_per_buyer_currencies_);
DCHECK(!values[16].IsEmpty());
}
if (hasPerBuyerExperimentGroupIds()) {
  values[17] = ToV8Traits<IDLRecord<IDLUSVString, IDLUnsignedShort>>::ToV8(script_state, member_per_buyer_experiment_group_ids_);
DCHECK(!values[17].IsEmpty());
}
if (hasPerBuyerGroupLimits()) {
  values[18] = ToV8Traits<IDLRecord<IDLUSVString, IDLUnsignedShort>>::ToV8(script_state, member_per_buyer_group_limits_);
DCHECK(!values[18].IsEmpty());
}
if (RuntimeEnabledFeatures::FledgeMultiBidEnabled()) {
  if (hasPerBuyerMultiBidLimits()) {
  values[19] = ToV8Traits<IDLRecord<IDLUSVString, IDLUnsignedShort>>::ToV8(script_state, member_per_buyer_multi_bid_limits_);
DCHECK(!values[19].IsEmpty());
}
}
if (hasPerBuyerPrioritySignals()) {
  values[20] = ToV8Traits<IDLRecord<IDLUSVString, IDLRecord<IDLUSVString, IDLDouble>>>::ToV8(script_state, member_per_buyer_priority_signals_);
DCHECK(!values[20].IsEmpty());
}
if (RuntimeEnabledFeatures::FledgeRealTimeReportingEnabled()) {
  if (hasPerBuyerRealTimeReportingConfig()) {
  values[21] = ToV8Traits<IDLRecord<IDLUSVString, AuctionRealTimeReportingConfig>>::ToV8(script_state, member_per_buyer_real_time_reporting_config_);
DCHECK(!values[21].IsEmpty());
}
}
if (hasPerBuyerSignals()) {
  values[22] = ToV8Traits<IDLPromise>::ToV8(script_state, member_per_buyer_signals_);
DCHECK(!values[22].IsEmpty());
}
if (hasPerBuyerTimeouts()) {
  values[23] = ToV8Traits<IDLPromise>::ToV8(script_state, member_per_buyer_timeouts_);
DCHECK(!values[23].IsEmpty());
}
if (hasPrivateAggregationConfig()) {
  values[24] = ToV8Traits<ProtectedAudiencePrivateAggregationConfig>::ToV8(script_state, member_private_aggregation_config_.Get());
DCHECK(!values[24].IsEmpty());
}
if (RuntimeEnabledFeatures::FledgeReportingTimeoutEnabled()) {
  if (hasReportingTimeout()) {
  values[25] = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_reporting_timeout_);
DCHECK(!values[25].IsEmpty());
}
}
if (hasRequestId()) {
  values[26] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_request_id_);
DCHECK(!values[26].IsEmpty());
}
if (hasRequestedSize()) {
  values[27] = ToV8Traits<AuctionAdInterestGroupSize>::ToV8(script_state, member_requested_size_.Get());
DCHECK(!values[27].IsEmpty());
}
if (hasRequiredSellerCapabilities()) {
  values[28] = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_required_seller_capabilities_);
DCHECK(!values[28].IsEmpty());
}
if (hasResolveToConfig()) {
  values[29] = ToV8Traits<IDLPromise>::ToV8(script_state, member_resolve_to_config_);
DCHECK(!values[29].IsEmpty());
}
if (hasSeller()) {
  values[30] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_seller_);
DCHECK(!values[30].IsEmpty());
}
if (hasSellerCurrency()) {
  values[31] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_seller_currency_);
DCHECK(!values[31].IsEmpty());
}
if (hasSellerExperimentGroupId()) {
  values[32] = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_seller_experiment_group_id_);
DCHECK(!values[32].IsEmpty());
}
if (RuntimeEnabledFeatures::FledgeRealTimeReportingEnabled()) {
  if (hasSellerRealTimeReportingConfig()) {
  values[33] = ToV8Traits<AuctionRealTimeReportingConfig>::ToV8(script_state, member_seller_real_time_reporting_config_.Get());
DCHECK(!values[33].IsEmpty());
}
}
if (hasSellerSignals()) {
  values[34] = ToV8Traits<IDLPromise>::ToV8(script_state, member_seller_signals_);
DCHECK(!values[34].IsEmpty());
}
if (hasSellerTimeout()) {
  values[35] = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_seller_timeout_);
DCHECK(!values[35].IsEmpty());
}
if (hasServerResponse()) {
  values[36] = ToV8Traits<IDLPromise>::ToV8(script_state, member_server_response_);
DCHECK(!values[36].IsEmpty());
}
if (hasSignal()) {
  values[37] = ToV8Traits<IDLNullable<AbortSignal>>::ToV8(script_state, member_signal_.Get());
DCHECK(!values[37].IsEmpty());
}
if (hasTrustedScoringSignalsURL()) {
  values[38] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_trusted_scoring_signals_url_);
DCHECK(!values[38].IsEmpty());
}
if (hasTrustedScoringSignalsUrlDeprecated()) {
  values[39] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_trusted_scoring_signals_url_deprecated_);
DCHECK(!values[39].IsEmpty());
}
}

const void* AuctionAdConfig::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> AuctionAdConfig::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void AuctionAdConfig::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuctionAdConfig";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (RuntimeEnabledFeatures::FledgeNegativeTargetingEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("additionalBids");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_additional_bids_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::FledgeTrustedBiddingSignalsSlotSizeEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("allSlotsRequestedSizes");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<AuctionAdInterestGroupSize>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_all_slots_requested_sizes_, member_all_slots_requested_sizes_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::FledgeNegativeTargetingEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("auctionNonce");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_auction_nonce_, member_auction_nonce_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::PrivateAggregationAuctionReportBuyerDebugModeConfigEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("auctionReportBuyerDebugModeConfig");
if (!bindings::GetDictionaryMemberFromV8Object<AuctionReportBuyerDebugModeConfig, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_auction_report_buyer_debug_mode_config_, member_auction_report_buyer_debug_mode_config_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("auctionReportBuyerKeys");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLBigint>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_auction_report_buyer_keys_, member_auction_report_buyer_keys_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("auctionReportBuyers");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLString, AuctionReportBuyersConfig>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_auction_report_buyers_, member_auction_report_buyers_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("auctionSignals");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_auction_signals_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("componentAuctions");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<AuctionAdConfig>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_component_auctions_, member_component_auctions_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("decisionLogicURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_decision_logic_url_, member_decision_logic_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("decisionLogicUrl");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_decision_logic_url_deprecated_, member_decision_logic_url_deprecated_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::FledgeDeprecatedRenderURLReplacementsEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("deprecatedRenderURLReplacements");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), fallback_presence_var, member_deprecated_render_url_replacements_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("directFromSellerSignals");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), fallback_presence_var, member_direct_from_seller_signals_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::FledgeDirectFromSellerSignalsHeaderAdSlotEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("directFromSellerSignalsHeaderAdSlot");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), fallback_presence_var, member_direct_from_seller_signals_header_ad_slot_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("interestGroupBuyers");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), has_interest_group_buyers_, member_interest_group_buyers_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("maxTrustedScoringSignalsURLLength");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[14].Get(isolate), has_max_trusted_scoring_signals_url_length_, member_max_trusted_scoring_signals_url_length_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("perBuyerCumulativeTimeouts");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[15].Get(isolate), fallback_presence_var, member_per_buyer_cumulative_timeouts_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("perBuyerCurrencies");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[16].Get(isolate), fallback_presence_var, member_per_buyer_currencies_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("perBuyerExperimentGroupIds");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLUnsignedShort>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[17].Get(isolate), has_per_buyer_experiment_group_ids_, member_per_buyer_experiment_group_ids_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("perBuyerGroupLimits");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLUnsignedShort>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[18].Get(isolate), has_per_buyer_group_limits_, member_per_buyer_group_limits_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::FledgeMultiBidEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("perBuyerMultiBidLimits");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLUnsignedShort>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[19].Get(isolate), has_per_buyer_multi_bid_limits_, member_per_buyer_multi_bid_limits_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("perBuyerPrioritySignals");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLRecord<IDLUSVString, IDLDouble>>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[20].Get(isolate), has_per_buyer_priority_signals_, member_per_buyer_priority_signals_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::FledgeRealTimeReportingEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("perBuyerRealTimeReportingConfig");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, AuctionRealTimeReportingConfig>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[21].Get(isolate), has_per_buyer_real_time_reporting_config_, member_per_buyer_real_time_reporting_config_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("perBuyerSignals");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[22].Get(isolate), fallback_presence_var, member_per_buyer_signals_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("perBuyerTimeouts");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[23].Get(isolate), fallback_presence_var, member_per_buyer_timeouts_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("privateAggregationConfig");
if (!bindings::GetDictionaryMemberFromV8Object<ProtectedAudiencePrivateAggregationConfig, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[24].Get(isolate), has_private_aggregation_config_, member_private_aggregation_config_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::FledgeReportingTimeoutEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("reportingTimeout");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[25].Get(isolate), has_reporting_timeout_, member_reporting_timeout_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[26].Get(isolate), has_request_id_, member_request_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestedSize");
if (!bindings::GetDictionaryMemberFromV8Object<AuctionAdInterestGroupSize, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[27].Get(isolate), has_requested_size_, member_requested_size_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requiredSellerCapabilities");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[28].Get(isolate), has_required_seller_capabilities_, member_required_seller_capabilities_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("resolveToConfig");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[29].Get(isolate), fallback_presence_var, member_resolve_to_config_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("seller");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[30].Get(isolate), fallback_presence_var, member_seller_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sellerCurrency");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[31].Get(isolate), has_seller_currency_, member_seller_currency_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sellerExperimentGroupId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[32].Get(isolate), has_seller_experiment_group_id_, member_seller_experiment_group_id_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::FledgeRealTimeReportingEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("sellerRealTimeReportingConfig");
if (!bindings::GetDictionaryMemberFromV8Object<AuctionRealTimeReportingConfig, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[33].Get(isolate), has_seller_real_time_reporting_config_, member_seller_real_time_reporting_config_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sellerSignals");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[34].Get(isolate), fallback_presence_var, member_seller_signals_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sellerTimeout");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[35].Get(isolate), has_seller_timeout_, member_seller_timeout_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("serverResponse");
if (!bindings::GetDictionaryMemberFromV8Object<IDLPromise, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[36].Get(isolate), fallback_presence_var, member_server_response_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("signal");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<AbortSignal>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[37].Get(isolate), has_signal_, member_signal_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("trustedScoringSignalsURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[38].Get(isolate), has_trusted_scoring_signals_url_, member_trusted_scoring_signals_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("trustedScoringSignalsUrl");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[39].Get(isolate), has_trusted_scoring_signals_url_deprecated_, member_trusted_scoring_signals_url_deprecated_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuctionAdConfig::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
