// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_large_blob_inputs_js_on.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"read",
"support",
"write",
};


}  // namespace 

AuthenticationExtensionsLargeBlobInputsJSON* AuthenticationExtensionsLargeBlobInputsJSON::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticationExtensionsLargeBlobInputsJSON* dictionary = MakeGarbageCollected<AuthenticationExtensionsLargeBlobInputsJSON>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticationExtensionsLargeBlobInputsJSON";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuthenticationExtensionsLargeBlobInputsJSON::AuthenticationExtensionsLargeBlobInputsJSON() {
  
}

 AuthenticationExtensionsLargeBlobInputsJSON::AuthenticationExtensionsLargeBlobInputsJSON(v8::Isolate* isolate) {
  
}










String AuthenticationExtensionsLargeBlobInputsJSON::getSupportOr(const String& fallback_value) const {
  if (!hasSupport()) {
  return fallback_value;
}
return member_support_;
}

String AuthenticationExtensionsLargeBlobInputsJSON::getSupportOr(String&& fallback_value) const {
  if (!hasSupport()) {
  return std::move(fallback_value);
}
return member_support_;
}

void AuthenticationExtensionsLargeBlobInputsJSON::setSupport(const String& value) {
  member_support_ = value;
has_support_ = true;
}

void AuthenticationExtensionsLargeBlobInputsJSON::setSupport(String&& value) {
  member_support_ = std::move(value);
has_support_ = true;
}




String AuthenticationExtensionsLargeBlobInputsJSON::getWriteOr(const String& fallback_value) const {
  if (!hasWrite()) {
  return fallback_value;
}
return member_write_;
}

String AuthenticationExtensionsLargeBlobInputsJSON::getWriteOr(String&& fallback_value) const {
  if (!hasWrite()) {
  return std::move(fallback_value);
}
return member_write_;
}

void AuthenticationExtensionsLargeBlobInputsJSON::setWrite(const String& value) {
  member_write_ = value;
has_write_ = true;
}

void AuthenticationExtensionsLargeBlobInputsJSON::setWrite(String&& value) {
  member_write_ = std::move(value);
has_write_ = true;
}




void AuthenticationExtensionsLargeBlobInputsJSON::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_read_);
TraceIfNeeded<String>::Trace(visitor, member_support_);
TraceIfNeeded<String>::Trace(visitor, member_write_);
bindings::DictionaryBase::Trace(visitor);
}

void AuthenticationExtensionsLargeBlobInputsJSON::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void AuthenticationExtensionsLargeBlobInputsJSON::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasRead()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_read_);
DCHECK(!values[0].IsEmpty());
}
if (hasSupport()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_support_);
DCHECK(!values[1].IsEmpty());
}
if (hasWrite()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_write_);
DCHECK(!values[2].IsEmpty());
}
}

const void* AuthenticationExtensionsLargeBlobInputsJSON::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> AuthenticationExtensionsLargeBlobInputsJSON::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void AuthenticationExtensionsLargeBlobInputsJSON::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuthenticationExtensionsLargeBlobInputsJSON";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("read");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_read_, member_read_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("support");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_support_, member_support_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("write");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_write_, member_write_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticationExtensionsLargeBlobInputsJSON::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
