// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_canvas_webgpu_access_option.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/webgpu/gpu_device.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"device",
"label",
"usage",
};


}  // namespace 

CanvasWebGPUAccessOption* CanvasWebGPUAccessOption::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CanvasWebGPUAccessOption* dictionary = MakeGarbageCollected<CanvasWebGPUAccessOption>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CanvasWebGPUAccessOption";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CanvasWebGPUAccessOption::CanvasWebGPUAccessOption() {
  
}

 CanvasWebGPUAccessOption::CanvasWebGPUAccessOption(v8::Isolate* isolate) {
  
}










String CanvasWebGPUAccessOption::getLabelOr(const String& fallback_value) const {
  if (!hasLabel()) {
  return fallback_value;
}
return member_label_;
}

String CanvasWebGPUAccessOption::getLabelOr(String&& fallback_value) const {
  if (!hasLabel()) {
  return std::move(fallback_value);
}
return member_label_;
}

void CanvasWebGPUAccessOption::setLabel(const String& value) {
  member_label_ = value;
has_label_ = true;
}

void CanvasWebGPUAccessOption::setLabel(String&& value) {
  member_label_ = std::move(value);
has_label_ = true;
}









void CanvasWebGPUAccessOption::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<GPUDevice>>::Trace(visitor, member_device_);
TraceIfNeeded<String>::Trace(visitor, member_label_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_usage_);
bindings::DictionaryBase::Trace(visitor);
}

void CanvasWebGPUAccessOption::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void CanvasWebGPUAccessOption::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasDevice()) {
  values[0] = ToV8Traits<GPUDevice>::ToV8(script_state, member_device_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasLabel()) {
  values[1] = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_label_);
DCHECK(!values[1].IsEmpty());
}
if (hasUsage()) {
  values[2] = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_usage_);
DCHECK(!values[2].IsEmpty());
}
}

const void* CanvasWebGPUAccessOption::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> CanvasWebGPUAccessOption::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void CanvasWebGPUAccessOption::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CanvasWebGPUAccessOption";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("device");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<GPUDevice, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_device_, member_device_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("label");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_label_, member_label_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("usage");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_usage_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> CanvasWebGPUAccessOption::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
