// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_credential_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_request_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_federated_credential_request_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_credential_request_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_otp_credential_request_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_request_options.h"
#include "third_party/blink/renderer/core/dom/abort_signal.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"digital",
"federated",
"identity",
"mediation",
"otp",
"password",
"publicKey",
"signal",
};


}  // namespace 

CredentialRequestOptions* CredentialRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CredentialRequestOptions* dictionary = MakeGarbageCollected<CredentialRequestOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CredentialRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CredentialRequestOptions::CredentialRequestOptions() {
  
}

 CredentialRequestOptions::CredentialRequestOptions(v8::Isolate* isolate) {
  
}























































void CredentialRequestOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<DigitalCredentialRequestOptions>>::Trace(visitor, member_digital_);
TraceIfNeeded<Member<FederatedCredentialRequestOptions>>::Trace(visitor, member_federated_);
TraceIfNeeded<Member<IdentityCredentialRequestOptions>>::Trace(visitor, member_identity_);
TraceIfNeeded<V8CredentialMediationRequirement>::Trace(visitor, member_mediation_);
TraceIfNeeded<Member<OTPCredentialRequestOptions>>::Trace(visitor, member_otp_);
TraceIfNeeded<bool>::Trace(visitor, member_password_);
TraceIfNeeded<Member<PublicKeyCredentialRequestOptions>>::Trace(visitor, member_public_key_);
TraceIfNeeded<Member<AbortSignal>>::Trace(visitor, member_signal_);
bindings::DictionaryBase::Trace(visitor);
}

void CredentialRequestOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void CredentialRequestOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::WebIdentityDigitalCredentialsEnabled(execution_context)) {
  if (hasDigital()) {
  values[0] = ToV8Traits<DigitalCredentialRequestOptions>::ToV8(script_state, member_digital_.Get());
DCHECK(!values[0].IsEmpty());
}
}
if (hasFederated()) {
  values[1] = ToV8Traits<FederatedCredentialRequestOptions>::ToV8(script_state, member_federated_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasIdentity()) {
  values[2] = ToV8Traits<IdentityCredentialRequestOptions>::ToV8(script_state, member_identity_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasMediation()) {
  values[3] = ToV8Traits<V8CredentialMediationRequirement>::ToV8(script_state, member_mediation_);
DCHECK(!values[3].IsEmpty());
}
if (RuntimeEnabledFeatures::WebOTPEnabled()) {
  if (hasOtp()) {
  values[4] = ToV8Traits<OTPCredentialRequestOptions>::ToV8(script_state, member_otp_.Get());
DCHECK(!values[4].IsEmpty());
}
}
if (hasPassword()) {
  values[5] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_password_);
DCHECK(!values[5].IsEmpty());
}
if (hasPublicKey()) {
  values[6] = ToV8Traits<PublicKeyCredentialRequestOptions>::ToV8(script_state, member_public_key_.Get());
DCHECK(!values[6].IsEmpty());
}
if (hasSignal()) {
  values[7] = ToV8Traits<AbortSignal>::ToV8(script_state, member_signal_.Get());
DCHECK(!values[7].IsEmpty());
}
}

const void* CredentialRequestOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> CredentialRequestOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void CredentialRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
ExecutionContext* execution_context = ExecutionContext::From(current_context);
const char* const class_like_name = "CredentialRequestOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (RuntimeEnabledFeatures::WebIdentityDigitalCredentialsEnabled(execution_context)) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("digital");
if (!bindings::GetDictionaryMemberFromV8Object<DigitalCredentialRequestOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_digital_, member_digital_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("federated");
if (!bindings::GetDictionaryMemberFromV8Object<FederatedCredentialRequestOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_federated_, member_federated_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("identity");
if (!bindings::GetDictionaryMemberFromV8Object<IdentityCredentialRequestOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_identity_, member_identity_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mediation");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8CredentialMediationRequirement, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_mediation_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::WebOTPEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("otp");
if (!bindings::GetDictionaryMemberFromV8Object<OTPCredentialRequestOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_otp_, member_otp_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("password");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_password_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("publicKey");
if (!bindings::GetDictionaryMemberFromV8Object<PublicKeyCredentialRequestOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_public_key_, member_public_key_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("signal");
if (!bindings::GetDictionaryMemberFromV8Object<AbortSignal, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_signal_, member_signal_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> CredentialRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
