// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_dynamics_compressor_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"attack",
"knee",
"ratio",
"release",
"threshold",
};


}  // namespace 

DynamicsCompressorOptions* DynamicsCompressorOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DynamicsCompressorOptions* dictionary = MakeGarbageCollected<DynamicsCompressorOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DynamicsCompressorOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 DynamicsCompressorOptions::DynamicsCompressorOptions() {
  
}

 DynamicsCompressorOptions::DynamicsCompressorOptions(v8::Isolate* isolate) : AudioNodeOptions(isolate) {
  
}




























void DynamicsCompressorOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<float>::Trace(visitor, member_attack_);
TraceIfNeeded<float>::Trace(visitor, member_knee_);
TraceIfNeeded<float>::Trace(visitor, member_ratio_);
TraceIfNeeded<float>::Trace(visitor, member_release_);
TraceIfNeeded<float>::Trace(visitor, member_threshold_);
AudioNodeOptions::Trace(visitor);
}

void DynamicsCompressorOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  AudioNodeOptions::FillTemplateProperties(properties);
DCHECK_EQ(properties.size(), kBasePropertyCount);

static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void DynamicsCompressorOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  AudioNodeOptions::FillValuesImpl(script_state, values.first(kBasePropertyCount));
values = values.subspan(kBasePropertyCount);

CHECK_EQ(kOwnPropertyCount, values.size());
if (hasAttack()) {
  values[0] = ToV8Traits<IDLFloat>::ToV8(script_state, member_attack_);
DCHECK(!values[0].IsEmpty());
}
if (hasKnee()) {
  values[1] = ToV8Traits<IDLFloat>::ToV8(script_state, member_knee_);
DCHECK(!values[1].IsEmpty());
}
if (hasRatio()) {
  values[2] = ToV8Traits<IDLFloat>::ToV8(script_state, member_ratio_);
DCHECK(!values[2].IsEmpty());
}
if (hasRelease()) {
  values[3] = ToV8Traits<IDLFloat>::ToV8(script_state, member_release_);
DCHECK(!values[3].IsEmpty());
}
if (hasThreshold()) {
  values[4] = ToV8Traits<IDLFloat>::ToV8(script_state, member_threshold_);
DCHECK(!values[4].IsEmpty());
}
}

const void* DynamicsCompressorOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> DynamicsCompressorOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void DynamicsCompressorOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  AudioNodeOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "DynamicsCompressorOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("attack");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_attack_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("knee");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_knee_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("ratio");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_ratio_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("release");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_release_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("threshold");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_threshold_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DynamicsCompressorOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
