// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_encoded_audio_chunk_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_arraybufferallowshared_arraybufferviewallowshared.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_decrypt_config.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"data",
"decryptConfig",
"duration",
"timestamp",
"transfer",
"type",
};


}  // namespace 

EncodedAudioChunkInit* EncodedAudioChunkInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  EncodedAudioChunkInit* dictionary = MakeGarbageCollected<EncodedAudioChunkInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "EncodedAudioChunkInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 EncodedAudioChunkInit::EncodedAudioChunkInit() {
  
}

 EncodedAudioChunkInit::EncodedAudioChunkInit(v8::Isolate* isolate) {
  
}



























void EncodedAudioChunkInit::setTransfer(const HeapVector<Member<DOMArrayBuffer>>& value) {
  member_transfer_ = value;
}

void EncodedAudioChunkInit::setTransfer(HeapVector<Member<DOMArrayBuffer>>&& value) {
  member_transfer_ = std::move(value);
}









void EncodedAudioChunkInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared>>::Trace(visitor, member_data_);
TraceIfNeeded<Member<DecryptConfig>>::Trace(visitor, member_decrypt_config_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_duration_);
TraceIfNeeded<int64_t>::Trace(visitor, member_timestamp_);
TraceIfNeeded<HeapVector<Member<DOMArrayBuffer>>>::Trace(visitor, member_transfer_);
TraceIfNeeded<V8EncodedAudioChunkType>::Trace(visitor, member_type_);
bindings::DictionaryBase::Trace(visitor);
}

void EncodedAudioChunkInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void EncodedAudioChunkInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasData()) {
  values[0] = ToV8Traits<V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared>::ToV8(script_state, member_data_.Get());
DCHECK(!values[0].IsEmpty());
}
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::MediaSourceExtensionsForWebCodecsEnabled(execution_context)) {
  if (hasDecryptConfig()) {
  values[1] = ToV8Traits<DecryptConfig>::ToV8(script_state, member_decrypt_config_.Get());
DCHECK(!values[1].IsEmpty());
}
}
if (hasDuration()) {
  values[2] = ToV8Traits<IDLUnsignedLongLongEnforceRange>::ToV8(script_state, member_duration_);
DCHECK(!values[2].IsEmpty());
}
if (hasTimestamp()) {
  values[3] = ToV8Traits<IDLLongLongEnforceRange>::ToV8(script_state, member_timestamp_);
DCHECK(!values[3].IsEmpty());
}
if (hasTransfer()) {
  values[4] = ToV8Traits<IDLSequence<DOMArrayBuffer>>::ToV8(script_state, member_transfer_);
DCHECK(!values[4].IsEmpty());
}
if (hasType()) {
  values[5] = ToV8Traits<V8EncodedAudioChunkType>::ToV8(script_state, member_type_);
DCHECK(!values[5].IsEmpty());
}
}

const void* EncodedAudioChunkInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> EncodedAudioChunkInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void EncodedAudioChunkInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "EncodedAudioChunkInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("data");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_data_, try_block, exception_state)) {
  return;
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
constexpr bool is_optional = false;
if (RuntimeEnabledFeatures::MediaSourceExtensionsForWebCodecsEnabled(execution_context)) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("decryptConfig");
if (!bindings::GetDictionaryMemberFromV8Object<DecryptConfig, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_decrypt_config_, member_decrypt_config_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("duration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_duration_, member_duration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("timestamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLongLongEnforceRange, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_timestamp_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transfer");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<DOMArrayBuffer>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_transfer_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("type");
if (!bindings::GetDictionaryMemberFromV8Object<V8EncodedAudioChunkType, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_type_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> EncodedAudioChunkInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
