// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_federated_credential_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"protocols",
"providers",
};


}  // namespace 

FederatedCredentialRequestOptions* FederatedCredentialRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  FederatedCredentialRequestOptions* dictionary = MakeGarbageCollected<FederatedCredentialRequestOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "FederatedCredentialRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 FederatedCredentialRequestOptions::FederatedCredentialRequestOptions() {
  
}

 FederatedCredentialRequestOptions::FederatedCredentialRequestOptions(v8::Isolate* isolate) {
  
}



Vector<String> FederatedCredentialRequestOptions::getProtocolsOr(const Vector<String>& fallback_value) const {
  if (!hasProtocols()) {
  return fallback_value;
}
return member_protocols_;
}

Vector<String> FederatedCredentialRequestOptions::getProtocolsOr(Vector<String>&& fallback_value) const {
  if (!hasProtocols()) {
  return std::move(fallback_value);
}
return member_protocols_;
}

void FederatedCredentialRequestOptions::setProtocols(const Vector<String>& value) {
  member_protocols_ = value;
has_protocols_ = true;
}

void FederatedCredentialRequestOptions::setProtocols(Vector<String>&& value) {
  member_protocols_ = std::move(value);
has_protocols_ = true;
}




Vector<String> FederatedCredentialRequestOptions::getProvidersOr(const Vector<String>& fallback_value) const {
  if (!hasProviders()) {
  return fallback_value;
}
return member_providers_;
}

Vector<String> FederatedCredentialRequestOptions::getProvidersOr(Vector<String>&& fallback_value) const {
  if (!hasProviders()) {
  return std::move(fallback_value);
}
return member_providers_;
}

void FederatedCredentialRequestOptions::setProviders(const Vector<String>& value) {
  member_providers_ = value;
has_providers_ = true;
}

void FederatedCredentialRequestOptions::setProviders(Vector<String>&& value) {
  member_providers_ = std::move(value);
has_providers_ = true;
}




void FederatedCredentialRequestOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<String>>::Trace(visitor, member_protocols_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_providers_);
bindings::DictionaryBase::Trace(visitor);
}

void FederatedCredentialRequestOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void FederatedCredentialRequestOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasProtocols()) {
  values[0] = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_protocols_);
DCHECK(!values[0].IsEmpty());
}
if (hasProviders()) {
  values[1] = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_providers_);
DCHECK(!values[1].IsEmpty());
}
}

const void* FederatedCredentialRequestOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> FederatedCredentialRequestOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void FederatedCredentialRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "FederatedCredentialRequestOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("protocols");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_protocols_, member_protocols_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("providers");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_providers_, member_providers_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> FederatedCredentialRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
