// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_file_picker_accept_type.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_usvstring_usvstringsequence.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"accept",
"description",
};


}  // namespace 

FilePickerAcceptType* FilePickerAcceptType::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  FilePickerAcceptType* dictionary = MakeGarbageCollected<FilePickerAcceptType>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "FilePickerAcceptType";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 FilePickerAcceptType::FilePickerAcceptType() {
  
}

 FilePickerAcceptType::FilePickerAcceptType(v8::Isolate* isolate) {
  
}



HeapVector<std::pair<String, Member<V8UnionUSVStringOrUSVStringSequence>>> FilePickerAcceptType::getAcceptOr(const HeapVector<std::pair<String, Member<V8UnionUSVStringOrUSVStringSequence>>>& fallback_value) const {
  if (!hasAccept()) {
  return fallback_value;
}
return member_accept_;
}

HeapVector<std::pair<String, Member<V8UnionUSVStringOrUSVStringSequence>>> FilePickerAcceptType::getAcceptOr(HeapVector<std::pair<String, Member<V8UnionUSVStringOrUSVStringSequence>>>&& fallback_value) const {
  if (!hasAccept()) {
  return std::move(fallback_value);
}
return member_accept_;
}

void FilePickerAcceptType::setAccept(const HeapVector<std::pair<String, Member<V8UnionUSVStringOrUSVStringSequence>>>& value) {
  member_accept_ = value;
has_accept_ = true;
}

void FilePickerAcceptType::setAccept(HeapVector<std::pair<String, Member<V8UnionUSVStringOrUSVStringSequence>>>&& value) {
  member_accept_ = std::move(value);
has_accept_ = true;
}




void FilePickerAcceptType::setDescription(const String& value) {
  member_description_ = value;
}

void FilePickerAcceptType::setDescription(String&& value) {
  member_description_ = std::move(value);
}




void FilePickerAcceptType::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<std::pair<String, Member<V8UnionUSVStringOrUSVStringSequence>>>>::Trace(visitor, member_accept_);
TraceIfNeeded<String>::Trace(visitor, member_description_);
bindings::DictionaryBase::Trace(visitor);
}

void FilePickerAcceptType::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void FilePickerAcceptType::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasAccept()) {
  values[0] = ToV8Traits<IDLRecord<IDLUSVString, V8UnionUSVStringOrUSVStringSequence>>::ToV8(script_state, member_accept_);
DCHECK(!values[0].IsEmpty());
}
if (hasDescription()) {
  values[1] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_description_);
DCHECK(!values[1].IsEmpty());
}
}

const void* FilePickerAcceptType::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> FilePickerAcceptType::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void FilePickerAcceptType::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "FilePickerAcceptType";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("accept");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, V8UnionUSVStringOrUSVStringSequence>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_accept_, member_accept_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("description");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_description_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> FilePickerAcceptType::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
