// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_depth_stencil_state.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_stencil_face_state.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"depthBias",
"depthBiasClamp",
"depthBiasSlopeScale",
"depthCompare",
"depthWriteEnabled",
"format",
"stencilBack",
"stencilFront",
"stencilReadMask",
"stencilWriteMask",
};


}  // namespace 

GPUDepthStencilState* GPUDepthStencilState::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUDepthStencilState* dictionary = MakeGarbageCollected<GPUDepthStencilState>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUDepthStencilState";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 GPUDepthStencilState::GPUDepthStencilState() : member_stencil_back_(GPUStencilFaceState::Create()), member_stencil_front_(GPUStencilFaceState::Create()) {
  
}

 GPUDepthStencilState::GPUDepthStencilState(v8::Isolate* isolate) : member_stencil_back_(GPUStencilFaceState::Create()), member_stencil_front_(GPUStencilFaceState::Create()) {
  
}

























































void GPUDepthStencilState::Trace(Visitor* visitor) const {
  TraceIfNeeded<int32_t>::Trace(visitor, member_depth_bias_);
TraceIfNeeded<float>::Trace(visitor, member_depth_bias_clamp_);
TraceIfNeeded<float>::Trace(visitor, member_depth_bias_slope_scale_);
TraceIfNeeded<V8GPUCompareFunction>::Trace(visitor, member_depth_compare_);
TraceIfNeeded<bool>::Trace(visitor, member_depth_write_enabled_);
TraceIfNeeded<V8GPUTextureFormat>::Trace(visitor, member_format_);
TraceIfNeeded<Member<GPUStencilFaceState>>::Trace(visitor, member_stencil_back_);
TraceIfNeeded<Member<GPUStencilFaceState>>::Trace(visitor, member_stencil_front_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_stencil_read_mask_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_stencil_write_mask_);
bindings::DictionaryBase::Trace(visitor);
}

void GPUDepthStencilState::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void GPUDepthStencilState::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasDepthBias()) {
  values[0] = ToV8Traits<IDLLongEnforceRange>::ToV8(script_state, member_depth_bias_);
DCHECK(!values[0].IsEmpty());
}
if (hasDepthBiasClamp()) {
  values[1] = ToV8Traits<IDLFloat>::ToV8(script_state, member_depth_bias_clamp_);
DCHECK(!values[1].IsEmpty());
}
if (hasDepthBiasSlopeScale()) {
  values[2] = ToV8Traits<IDLFloat>::ToV8(script_state, member_depth_bias_slope_scale_);
DCHECK(!values[2].IsEmpty());
}
if (hasDepthCompare()) {
  values[3] = ToV8Traits<V8GPUCompareFunction>::ToV8(script_state, member_depth_compare_);
DCHECK(!values[3].IsEmpty());
}
if (hasDepthWriteEnabled()) {
  values[4] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_depth_write_enabled_);
DCHECK(!values[4].IsEmpty());
}
if (hasFormat()) {
  values[5] = ToV8Traits<V8GPUTextureFormat>::ToV8(script_state, member_format_);
DCHECK(!values[5].IsEmpty());
}
if (hasStencilBack()) {
  values[6] = ToV8Traits<GPUStencilFaceState>::ToV8(script_state, member_stencil_back_.Get());
DCHECK(!values[6].IsEmpty());
}
if (hasStencilFront()) {
  values[7] = ToV8Traits<GPUStencilFaceState>::ToV8(script_state, member_stencil_front_.Get());
DCHECK(!values[7].IsEmpty());
}
if (hasStencilReadMask()) {
  values[8] = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_stencil_read_mask_);
DCHECK(!values[8].IsEmpty());
}
if (hasStencilWriteMask()) {
  values[9] = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_stencil_write_mask_);
DCHECK(!values[9].IsEmpty());
}
}

const void* GPUDepthStencilState::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> GPUDepthStencilState::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void GPUDepthStencilState::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "GPUDepthStencilState";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthBias");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_depth_bias_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthBiasClamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_depth_bias_clamp_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthBiasSlopeScale");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_depth_bias_slope_scale_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthCompare");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUCompareFunction, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_depth_compare_, member_depth_compare_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthWriteEnabled");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_depth_write_enabled_, member_depth_write_enabled_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("format");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUTextureFormat, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_format_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stencilBack");
if (!bindings::GetDictionaryMemberFromV8Object<GPUStencilFaceState, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_stencil_back_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stencilFront");
if (!bindings::GetDictionaryMemberFromV8Object<GPUStencilFaceState, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_stencil_front_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stencilReadMask");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_stencil_read_mask_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stencilWriteMask");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_stencil_write_mask_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUDepthStencilState::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
