// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_lstm_cell_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/ml/webnn/ml_activation.h"
#include "third_party/blink/renderer/modules/ml/webnn/ml_operand.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"activations",
"bias",
"layout",
"peepholeWeight",
"recurrentBias",
};


}  // namespace 

MLLstmCellOptions* MLLstmCellOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLLstmCellOptions* dictionary = MakeGarbageCollected<MLLstmCellOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLLstmCellOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MLLstmCellOptions::MLLstmCellOptions() {
  
}

 MLLstmCellOptions::MLLstmCellOptions(v8::Isolate* isolate) {
  
}



HeapVector<Member<MLActivation>> MLLstmCellOptions::getActivationsOr(const HeapVector<Member<MLActivation>>& fallback_value) const {
  if (!hasActivations()) {
  return fallback_value;
}
return member_activations_;
}

HeapVector<Member<MLActivation>> MLLstmCellOptions::getActivationsOr(HeapVector<Member<MLActivation>>&& fallback_value) const {
  if (!hasActivations()) {
  return std::move(fallback_value);
}
return member_activations_;
}

void MLLstmCellOptions::setActivations(const HeapVector<Member<MLActivation>>& value) {
  member_activations_ = value;
has_activations_ = true;
}

void MLLstmCellOptions::setActivations(HeapVector<Member<MLActivation>>&& value) {
  member_activations_ = std::move(value);
has_activations_ = true;
}






























void MLLstmCellOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<MLActivation>>>::Trace(visitor, member_activations_);
TraceIfNeeded<Member<MLOperand>>::Trace(visitor, member_bias_);
TraceIfNeeded<V8MLLstmWeightLayout>::Trace(visitor, member_layout_);
TraceIfNeeded<Member<MLOperand>>::Trace(visitor, member_peephole_weight_);
TraceIfNeeded<Member<MLOperand>>::Trace(visitor, member_recurrent_bias_);
bindings::DictionaryBase::Trace(visitor);
}

void MLLstmCellOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void MLLstmCellOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasActivations()) {
  values[0] = ToV8Traits<IDLSequence<MLActivation>>::ToV8(script_state, member_activations_);
DCHECK(!values[0].IsEmpty());
}
if (hasBias()) {
  values[1] = ToV8Traits<MLOperand>::ToV8(script_state, member_bias_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasLayout()) {
  values[2] = ToV8Traits<V8MLLstmWeightLayout>::ToV8(script_state, member_layout_);
DCHECK(!values[2].IsEmpty());
}
if (hasPeepholeWeight()) {
  values[3] = ToV8Traits<MLOperand>::ToV8(script_state, member_peephole_weight_.Get());
DCHECK(!values[3].IsEmpty());
}
if (hasRecurrentBias()) {
  values[4] = ToV8Traits<MLOperand>::ToV8(script_state, member_recurrent_bias_.Get());
DCHECK(!values[4].IsEmpty());
}
}

const void* MLLstmCellOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> MLLstmCellOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void MLLstmCellOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MLLstmCellOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("activations");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<MLActivation>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_activations_, member_activations_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bias");
if (!bindings::GetDictionaryMemberFromV8Object<MLOperand, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_bias_, member_bias_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("layout");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8MLLstmWeightLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_layout_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("peepholeWeight");
if (!bindings::GetDictionaryMemberFromV8Object<MLOperand, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_peephole_weight_, member_peephole_weight_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("recurrentBias");
if (!bindings::GetDictionaryMemberFromV8Object<MLOperand, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_recurrent_bias_, member_recurrent_bias_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLLstmCellOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
