// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_payment_validation_errors.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_address_errors.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_payer_errors.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"error",
"payer",
"shippingAddress",
};


}  // namespace 

PaymentValidationErrors* PaymentValidationErrors::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PaymentValidationErrors* dictionary = MakeGarbageCollected<PaymentValidationErrors>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PaymentValidationErrors";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 PaymentValidationErrors::PaymentValidationErrors() {
  
}

 PaymentValidationErrors::PaymentValidationErrors(v8::Isolate* isolate) {
  
}



String PaymentValidationErrors::getErrorOr(const String& fallback_value) const {
  if (!hasError()) {
  return fallback_value;
}
return member_error_;
}

String PaymentValidationErrors::getErrorOr(String&& fallback_value) const {
  if (!hasError()) {
  return std::move(fallback_value);
}
return member_error_;
}

void PaymentValidationErrors::setError(const String& value) {
  member_error_ = value;
has_error_ = true;
}

void PaymentValidationErrors::setError(String&& value) {
  member_error_ = std::move(value);
has_error_ = true;
}


















void PaymentValidationErrors::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_error_);
TraceIfNeeded<Member<PayerErrors>>::Trace(visitor, member_payer_);
TraceIfNeeded<Member<AddressErrors>>::Trace(visitor, member_shipping_address_);
bindings::DictionaryBase::Trace(visitor);
}

void PaymentValidationErrors::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void PaymentValidationErrors::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasError()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_error_);
DCHECK(!values[0].IsEmpty());
}
if (hasPayer()) {
  values[1] = ToV8Traits<PayerErrors>::ToV8(script_state, member_payer_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasShippingAddress()) {
  values[2] = ToV8Traits<AddressErrors>::ToV8(script_state, member_shipping_address_.Get());
DCHECK(!values[2].IsEmpty());
}
}

const void* PaymentValidationErrors::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> PaymentValidationErrors::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void PaymentValidationErrors::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "PaymentValidationErrors";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("error");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_error_, member_error_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("payer");
if (!bindings::GetDictionaryMemberFromV8Object<PayerErrors, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_payer_, member_payer_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("shippingAddress");
if (!bindings::GetDictionaryMemberFromV8Object<AddressErrors, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_shipping_address_, member_shipping_address_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PaymentValidationErrors::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
