// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_creation_options_js_on.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_client_inputs_js_on.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authenticator_selection_criteria.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_descriptor_js_on.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_parameters.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_rp_entity.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_user_entity_js_on.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"attestation",
"authenticatorSelection",
"challenge",
"excludeCredentials",
"extensions",
"hints",
"pubKeyCredParams",
"rp",
"timeout",
"user",
};


}  // namespace 

PublicKeyCredentialCreationOptionsJSON* PublicKeyCredentialCreationOptionsJSON::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PublicKeyCredentialCreationOptionsJSON* dictionary = MakeGarbageCollected<PublicKeyCredentialCreationOptionsJSON>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PublicKeyCredentialCreationOptionsJSON";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 PublicKeyCredentialCreationOptionsJSON::PublicKeyCredentialCreationOptionsJSON() {
  
}

 PublicKeyCredentialCreationOptionsJSON::PublicKeyCredentialCreationOptionsJSON(v8::Isolate* isolate) {
  
}



void PublicKeyCredentialCreationOptionsJSON::setAttestation(const String& value) {
  member_attestation_ = value;
}

void PublicKeyCredentialCreationOptionsJSON::setAttestation(String&& value) {
  member_attestation_ = std::move(value);
}











void PublicKeyCredentialCreationOptionsJSON::setChallenge(const String& value) {
  member_challenge_ = value;
}

void PublicKeyCredentialCreationOptionsJSON::setChallenge(String&& value) {
  member_challenge_ = std::move(value);
}




void PublicKeyCredentialCreationOptionsJSON::setExcludeCredentials(const HeapVector<Member<PublicKeyCredentialDescriptorJSON>>& value) {
  member_exclude_credentials_ = value;
}

void PublicKeyCredentialCreationOptionsJSON::setExcludeCredentials(HeapVector<Member<PublicKeyCredentialDescriptorJSON>>&& value) {
  member_exclude_credentials_ = std::move(value);
}











void PublicKeyCredentialCreationOptionsJSON::setHints(const Vector<String>& value) {
  member_hints_ = value;
}

void PublicKeyCredentialCreationOptionsJSON::setHints(Vector<String>&& value) {
  member_hints_ = std::move(value);
}




void PublicKeyCredentialCreationOptionsJSON::setPubKeyCredParams(const HeapVector<Member<PublicKeyCredentialParameters>>& value) {
  member_pub_key_cred_params_ = value;
}

void PublicKeyCredentialCreationOptionsJSON::setPubKeyCredParams(HeapVector<Member<PublicKeyCredentialParameters>>&& value) {
  member_pub_key_cred_params_ = std::move(value);
}





















void PublicKeyCredentialCreationOptionsJSON::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_attestation_);
TraceIfNeeded<Member<AuthenticatorSelectionCriteria>>::Trace(visitor, member_authenticator_selection_);
TraceIfNeeded<String>::Trace(visitor, member_challenge_);
TraceIfNeeded<HeapVector<Member<PublicKeyCredentialDescriptorJSON>>>::Trace(visitor, member_exclude_credentials_);
TraceIfNeeded<Member<AuthenticationExtensionsClientInputsJSON>>::Trace(visitor, member_extensions_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_hints_);
TraceIfNeeded<HeapVector<Member<PublicKeyCredentialParameters>>>::Trace(visitor, member_pub_key_cred_params_);
TraceIfNeeded<Member<PublicKeyCredentialRpEntity>>::Trace(visitor, member_rp_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_timeout_);
TraceIfNeeded<Member<PublicKeyCredentialUserEntityJSON>>::Trace(visitor, member_user_);
bindings::DictionaryBase::Trace(visitor);
}

void PublicKeyCredentialCreationOptionsJSON::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void PublicKeyCredentialCreationOptionsJSON::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasAttestation()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_attestation_);
DCHECK(!values[0].IsEmpty());
}
if (hasAuthenticatorSelection()) {
  values[1] = ToV8Traits<AuthenticatorSelectionCriteria>::ToV8(script_state, member_authenticator_selection_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasChallenge()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_challenge_);
DCHECK(!values[2].IsEmpty());
}
if (hasExcludeCredentials()) {
  values[3] = ToV8Traits<IDLSequence<PublicKeyCredentialDescriptorJSON>>::ToV8(script_state, member_exclude_credentials_);
DCHECK(!values[3].IsEmpty());
}
if (hasExtensions()) {
  values[4] = ToV8Traits<AuthenticationExtensionsClientInputsJSON>::ToV8(script_state, member_extensions_.Get());
DCHECK(!values[4].IsEmpty());
}
if (hasHints()) {
  values[5] = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_hints_);
DCHECK(!values[5].IsEmpty());
}
if (hasPubKeyCredParams()) {
  values[6] = ToV8Traits<IDLSequence<PublicKeyCredentialParameters>>::ToV8(script_state, member_pub_key_cred_params_);
DCHECK(!values[6].IsEmpty());
}
if (hasRp()) {
  values[7] = ToV8Traits<PublicKeyCredentialRpEntity>::ToV8(script_state, member_rp_.Get());
DCHECK(!values[7].IsEmpty());
}
if (hasTimeout()) {
  values[8] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_timeout_);
DCHECK(!values[8].IsEmpty());
}
if (hasUser()) {
  values[9] = ToV8Traits<PublicKeyCredentialUserEntityJSON>::ToV8(script_state, member_user_.Get());
DCHECK(!values[9].IsEmpty());
}
}

const void* PublicKeyCredentialCreationOptionsJSON::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> PublicKeyCredentialCreationOptionsJSON::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void PublicKeyCredentialCreationOptionsJSON::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "PublicKeyCredentialCreationOptionsJSON";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("attestation");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_attestation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("authenticatorSelection");
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticatorSelectionCriteria, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_authenticator_selection_, member_authenticator_selection_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("challenge");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_challenge_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("excludeCredentials");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<PublicKeyCredentialDescriptorJSON>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_exclude_credentials_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("extensions");
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticationExtensionsClientInputsJSON, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_extensions_, member_extensions_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("hints");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_hints_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pubKeyCredParams");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<PublicKeyCredentialParameters>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_pub_key_cred_params_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rp");
if (!bindings::GetDictionaryMemberFromV8Object<PublicKeyCredentialRpEntity, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_rp_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("timeout");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_timeout_, member_timeout_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("user");
if (!bindings::GetDictionaryMemberFromV8Object<PublicKeyCredentialUserEntityJSON, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_user_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PublicKeyCredentialCreationOptionsJSON::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
