// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_router_condition.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_urlpattern_urlpatterninit_usvstring.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_url_pattern_init.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_router_condition.h"
#include "third_party/blink/renderer/core/url_pattern/url_pattern.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"not",
"or",
"requestDestination",
"requestMethod",
"requestMode",
"runningStatus",
"urlPattern",
};


}  // namespace 

RouterCondition* RouterCondition::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RouterCondition* dictionary = MakeGarbageCollected<RouterCondition>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RouterCondition";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RouterCondition::RouterCondition() {
  
}

 RouterCondition::RouterCondition(v8::Isolate* isolate) {
  
}










HeapVector<Member<RouterCondition>> RouterCondition::getOrConditionsOr(const HeapVector<Member<RouterCondition>>& fallback_value) const {
  if (!hasOrConditions()) {
  return fallback_value;
}
return member_or_conditions_;
}

HeapVector<Member<RouterCondition>> RouterCondition::getOrConditionsOr(HeapVector<Member<RouterCondition>>&& fallback_value) const {
  if (!hasOrConditions()) {
  return std::move(fallback_value);
}
return member_or_conditions_;
}

void RouterCondition::setOrConditions(const HeapVector<Member<RouterCondition>>& value) {
  member_or_conditions_ = value;
has_or_conditions_ = true;
}

void RouterCondition::setOrConditions(HeapVector<Member<RouterCondition>>&& value) {
  member_or_conditions_ = std::move(value);
has_or_conditions_ = true;
}











String RouterCondition::getRequestMethodOr(const String& fallback_value) const {
  if (!hasRequestMethod()) {
  return fallback_value;
}
return member_request_method_;
}

String RouterCondition::getRequestMethodOr(String&& fallback_value) const {
  if (!hasRequestMethod()) {
  return std::move(fallback_value);
}
return member_request_method_;
}

void RouterCondition::setRequestMethod(const String& value) {
  member_request_method_ = value;
has_request_method_ = true;
}

void RouterCondition::setRequestMethod(String&& value) {
  member_request_method_ = std::move(value);
has_request_method_ = true;
}

























void RouterCondition::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<RouterCondition>>::Trace(visitor, member_not_condition_);
TraceIfNeeded<HeapVector<Member<RouterCondition>>>::Trace(visitor, member_or_conditions_);
TraceIfNeeded<V8RequestDestination>::Trace(visitor, member_request_destination_);
TraceIfNeeded<String>::Trace(visitor, member_request_method_);
TraceIfNeeded<V8RequestMode>::Trace(visitor, member_request_mode_);
TraceIfNeeded<V8RunningStatusEnum>::Trace(visitor, member_running_status_);
TraceIfNeeded<Member<V8UnionURLPatternOrURLPatternInitOrUSVString>>::Trace(visitor, member_url_pattern_);
bindings::DictionaryBase::Trace(visitor);
}

void RouterCondition::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void RouterCondition::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasNotCondition()) {
  values[0] = ToV8Traits<RouterCondition>::ToV8(script_state, member_not_condition_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasOrConditions()) {
  values[1] = ToV8Traits<IDLSequence<RouterCondition>>::ToV8(script_state, member_or_conditions_);
DCHECK(!values[1].IsEmpty());
}
if (hasRequestDestination()) {
  values[2] = ToV8Traits<V8RequestDestination>::ToV8(script_state, member_request_destination_);
DCHECK(!values[2].IsEmpty());
}
if (hasRequestMethod()) {
  values[3] = ToV8Traits<IDLByteString>::ToV8(script_state, member_request_method_);
DCHECK(!values[3].IsEmpty());
}
if (hasRequestMode()) {
  values[4] = ToV8Traits<V8RequestMode>::ToV8(script_state, member_request_mode_);
DCHECK(!values[4].IsEmpty());
}
if (hasRunningStatus()) {
  values[5] = ToV8Traits<V8RunningStatusEnum>::ToV8(script_state, member_running_status_);
DCHECK(!values[5].IsEmpty());
}
if (hasUrlPattern()) {
  values[6] = ToV8Traits<V8UnionURLPatternOrURLPatternInitOrUSVString>::ToV8(script_state, member_url_pattern_.Get());
DCHECK(!values[6].IsEmpty());
}
}

const void* RouterCondition::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> RouterCondition::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void RouterCondition::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "RouterCondition";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("not");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<RouterCondition, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_not_condition_, member_not_condition_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("or");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<RouterCondition>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_or_conditions_, member_or_conditions_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestDestination");
if (!bindings::GetDictionaryMemberFromV8Object<V8RequestDestination, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_request_destination_, member_request_destination_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestMethod");
if (!bindings::GetDictionaryMemberFromV8Object<IDLByteString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_request_method_, member_request_method_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestMode");
if (!bindings::GetDictionaryMemberFromV8Object<V8RequestMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_request_mode_, member_request_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("runningStatus");
if (!bindings::GetDictionaryMemberFromV8Object<V8RunningStatusEnum, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_running_status_, member_running_status_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("urlPattern");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionURLPatternOrURLPatternInitOrUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_url_pattern_, member_url_pattern_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RouterCondition::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
