// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_storage_bucket_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"durability",
"expires",
"persisted",
"quota",
};


}  // namespace 

StorageBucketOptions* StorageBucketOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  StorageBucketOptions* dictionary = MakeGarbageCollected<StorageBucketOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "StorageBucketOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 StorageBucketOptions::StorageBucketOptions() {
  
}

 StorageBucketOptions::StorageBucketOptions(v8::Isolate* isolate) {
  
}































void StorageBucketOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8StorageBucketDurability>::Trace(visitor, member_durability_);
TraceIfNeeded<double>::Trace(visitor, member_expires_);
TraceIfNeeded<bool>::Trace(visitor, member_persisted_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_quota_);
bindings::DictionaryBase::Trace(visitor);
}

void StorageBucketOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void StorageBucketOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (RuntimeEnabledFeatures::StorageBucketsDurabilityEnabled()) {
  if (hasDurability()) {
  values[0] = ToV8Traits<V8StorageBucketDurability>::ToV8(script_state, member_durability_);
DCHECK(!values[0].IsEmpty());
}
}
if (hasExpires()) {
  values[1] = ToV8Traits<IDLDouble>::ToV8(script_state, member_expires_);
DCHECK(!values[1].IsEmpty());
}
if (hasPersisted()) {
  values[2] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_persisted_);
DCHECK(!values[2].IsEmpty());
}
if (hasQuota()) {
  values[3] = ToV8Traits<IDLUnsignedLongLongEnforceRange>::ToV8(script_state, member_quota_);
DCHECK(!values[3].IsEmpty());
}
}

const void* StorageBucketOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> StorageBucketOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void StorageBucketOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "StorageBucketOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (RuntimeEnabledFeatures::StorageBucketsDurabilityEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("durability");
if (!bindings::GetDictionaryMemberFromV8Object<V8StorageBucketDurability, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_durability_, member_durability_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("expires");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_expires_, member_expires_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("persisted");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_persisted_, member_persisted_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("quota");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_quota_, member_quota_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> StorageBucketOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
