// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_web_print_job_template_attributes.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_web_printing_media_collection_requested.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_web_printing_resolution.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"copies",
"mediaCol",
"mediaSource",
"multipleDocumentHandling",
"orientationRequested",
"printColorMode",
"printQuality",
"printerResolution",
"sides",
};


}  // namespace 

WebPrintJobTemplateAttributes* WebPrintJobTemplateAttributes::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WebPrintJobTemplateAttributes* dictionary = MakeGarbageCollected<WebPrintJobTemplateAttributes>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WebPrintJobTemplateAttributes";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 WebPrintJobTemplateAttributes::WebPrintJobTemplateAttributes() {
  
}

 WebPrintJobTemplateAttributes::WebPrintJobTemplateAttributes(v8::Isolate* isolate) {
  
}

















String WebPrintJobTemplateAttributes::getMediaSourceOr(const String& fallback_value) const {
  if (!hasMediaSource()) {
  return fallback_value;
}
return member_media_source_;
}

String WebPrintJobTemplateAttributes::getMediaSourceOr(String&& fallback_value) const {
  if (!hasMediaSource()) {
  return std::move(fallback_value);
}
return member_media_source_;
}

void WebPrintJobTemplateAttributes::setMediaSource(const String& value) {
  member_media_source_ = value;
has_media_source_ = true;
}

void WebPrintJobTemplateAttributes::setMediaSource(String&& value) {
  member_media_source_ = std::move(value);
has_media_source_ = true;
}














































void WebPrintJobTemplateAttributes::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_copies_);
TraceIfNeeded<Member<WebPrintingMediaCollectionRequested>>::Trace(visitor, member_media_col_);
TraceIfNeeded<String>::Trace(visitor, member_media_source_);
TraceIfNeeded<V8WebPrintingMultipleDocumentHandling>::Trace(visitor, member_multiple_document_handling_);
TraceIfNeeded<V8WebPrintingOrientationRequested>::Trace(visitor, member_orientation_requested_);
TraceIfNeeded<V8WebPrintColorMode>::Trace(visitor, member_print_color_mode_);
TraceIfNeeded<V8WebPrintQuality>::Trace(visitor, member_print_quality_);
TraceIfNeeded<Member<WebPrintingResolution>>::Trace(visitor, member_printer_resolution_);
TraceIfNeeded<V8WebPrintingSides>::Trace(visitor, member_sides_);
bindings::DictionaryBase::Trace(visitor);
}

void WebPrintJobTemplateAttributes::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void WebPrintJobTemplateAttributes::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasCopies()) {
  values[0] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_copies_);
DCHECK(!values[0].IsEmpty());
}
if (hasMediaCol()) {
  values[1] = ToV8Traits<WebPrintingMediaCollectionRequested>::ToV8(script_state, member_media_col_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasMediaSource()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_media_source_);
DCHECK(!values[2].IsEmpty());
}
if (hasMultipleDocumentHandling()) {
  values[3] = ToV8Traits<V8WebPrintingMultipleDocumentHandling>::ToV8(script_state, member_multiple_document_handling_);
DCHECK(!values[3].IsEmpty());
}
if (hasOrientationRequested()) {
  values[4] = ToV8Traits<V8WebPrintingOrientationRequested>::ToV8(script_state, member_orientation_requested_);
DCHECK(!values[4].IsEmpty());
}
if (hasPrintColorMode()) {
  values[5] = ToV8Traits<V8WebPrintColorMode>::ToV8(script_state, member_print_color_mode_);
DCHECK(!values[5].IsEmpty());
}
if (hasPrintQuality()) {
  values[6] = ToV8Traits<V8WebPrintQuality>::ToV8(script_state, member_print_quality_);
DCHECK(!values[6].IsEmpty());
}
if (hasPrinterResolution()) {
  values[7] = ToV8Traits<WebPrintingResolution>::ToV8(script_state, member_printer_resolution_.Get());
DCHECK(!values[7].IsEmpty());
}
if (hasSides()) {
  values[8] = ToV8Traits<V8WebPrintingSides>::ToV8(script_state, member_sides_);
DCHECK(!values[8].IsEmpty());
}
}

const void* WebPrintJobTemplateAttributes::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> WebPrintJobTemplateAttributes::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void WebPrintJobTemplateAttributes::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "WebPrintJobTemplateAttributes";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("copies");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_copies_, member_copies_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mediaCol");
if (!bindings::GetDictionaryMemberFromV8Object<WebPrintingMediaCollectionRequested, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_media_col_, member_media_col_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mediaSource");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_media_source_, member_media_source_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("multipleDocumentHandling");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintingMultipleDocumentHandling, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_multiple_document_handling_, member_multiple_document_handling_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("orientationRequested");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintingOrientationRequested, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_orientation_requested_, member_orientation_requested_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printColorMode");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintColorMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_print_color_mode_, member_print_color_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printQuality");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintQuality, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_print_quality_, member_print_quality_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printerResolution");
if (!bindings::GetDictionaryMemberFromV8Object<WebPrintingResolution, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_printer_resolution_, member_printer_resolution_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sides");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintingSides, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_sides_, member_sides_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> WebPrintJobTemplateAttributes::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
