// https://source.chromium.org/chromium/chromium/src/+/main:v8/src/objects/js-disposable-stack.tq?l=15&c=3
template<class D, class P>
Tagged<FixedArray> TorqueGeneratedJSDisposableStack<D, P>::stack() const {
  PtrComprCageBase cage_base = GetPtrComprCageBase(*this);
  return TorqueGeneratedJSDisposableStack::stack(cage_base);
}

// https://source.chromium.org/chromium/chromium/src/+/main:v8/src/objects/js-disposable-stack.tq?l=15&c=3
template<class D, class P>
Tagged<FixedArray> TorqueGeneratedJSDisposableStack<D, P>::stack(PtrComprCageBase cage_base) const {
  Tagged<FixedArray> value = TaggedField<Tagged<FixedArray>>::load(cage_base, *this, kStackOffset);
  DCHECK(IsFixedArray(value));
  return value;
}

// https://source.chromium.org/chromium/chromium/src/+/main:v8/src/objects/js-disposable-stack.tq?l=15&c=3
template<class D, class P>
void TorqueGeneratedJSDisposableStack<D, P>::set_stack(Tagged<FixedArray> value, WriteBarrierMode mode) {
  SLOW_DCHECK(IsFixedArray(value));
  WRITE_FIELD(*this, kStackOffset, value);
  CONDITIONAL_WRITE_BARRIER(*this, kStackOffset, value, mode);
}

// https://source.chromium.org/chromium/chromium/src/+/main:v8/src/objects/js-disposable-stack.tq?l=16&c=3
template<class D, class P>
int TorqueGeneratedJSDisposableStack<D, P>::status() const {
  int value = TaggedField<Smi>::load(*this, kStatusOffset).value();
  return value;
}

// https://source.chromium.org/chromium/chromium/src/+/main:v8/src/objects/js-disposable-stack.tq?l=16&c=3
template<class D, class P>
void TorqueGeneratedJSDisposableStack<D, P>::set_status(int value) {
  WRITE_FIELD(*this, kStatusOffset, Smi::FromInt(value));
}

// https://source.chromium.org/chromium/chromium/src/+/main:v8/src/objects/js-disposable-stack.tq?l=12&c=1
template<class D, class P>
Tagged<D> TorqueGeneratedJSDisposableStack<D, P>::cast(Tagged<Object> object) {
    return Tagged<D>(D(object.ptr()));
}

template<class D, class P>
inline TorqueGeneratedJSDisposableStack<D, P>::TorqueGeneratedJSDisposableStack(Address ptr)
    : P(ptr) {
  SLOW_DCHECK(IsJSDisposableStack_NonInline(*this));
}
